	subroutine trh2sh(temp,relhum,press,sphum)
c
c	convert temp, relhum -> specific humidity
c
c	temp (kelvin)
c	relhum (0..100)
c	press (mb)
c	specific humidity (kg/kg)
c
        parameter (RLRV = 2.5E6 / 4.6150E2)
	real temp, relhum, press, sphum, const, es, eofp, w

c	write(*,*) 'rh->sh ',temp,relhum,press

	if (relhum.le.0.0) then
	    sphum = 0.0
	    return
	endif

        CONST = 6.1078 * EXP(RLRV / 273.16)

C       ES, EOFP, PRESS MUST BE IN THE SAME UNITS
C       ES = SATURATION VAPOR PRESSURE
C       EOFP = VAPOR PRESSURE
C       W = MIXING RATIO

	ES = CONST / EXP(RLRV/temp)
	EOFP=RELHUM*ES/100.0
        w = 0.622 * EOFP / (PRESS - 0.378 * EOFP)

c	for g/kg
c	sphum = w / (1.0 + w) * 1000.0

c	for kg/kg
	sphum = w / (1.0 + w)
	return
	end

	program gribslp
c
c	a program to find sea-level pressure
c
c	uses same method as GDAS
c
c	this program is built along the lines of
c	grib_covar.f
c
c	file 50: seq grib file-x -- Z1000
c	file 51: index grib file-x
c	file 52: seq grib file- Z500
c	file 53: index grib file-y
c	file 54: list of times [yyyymmddhh]
c
c	file 1: output file seq grib - slp
c
	parameter (maxv=100000)

	logical lbmsx(maxv), lbmsy(maxv)
	real z1000(maxv), z500(maxv), slp(maxv)
	integer icount

	integer kpdsx(100),kgdsx(100),reclx,offsetx
	integer kpdsy(100),kgdsy(100),recly,offsety
	integer kpdsx6, kpdsx7
	integer kpdsy6, kpdsy7
	integer kpdsz6, kpdsz7

	integer idx, idy, newid, time, time2, year, mon, hour, day
	real levelz
	logical hasbtx, hasbty

	write(*,*) 'grib_slp'

	call baopen(50,'fort.50',iret)
	if (iret.ne.0) then
	    write(*,*) 'error: could not open unit 50'
	    call exit(8)
	endif

	call baopen(51,'fort.51',iret)
	if (iret.ne.0) then
	    write(*,*) 'error: could not open unit 51'
	    call exit(8)
	endif

	call baopen(52,'fort.52',iret)
	if (iret.ne.0) then
	    write(*,*) 'error: could not open unit 52'
	    call exit(8)
	endif

	call baopen(53,'fort.53',iret)
	if (iret.ne.0) then
	    write(*,*) 'error: could not open unit 52'
	    call exit(8)
	endif

c	find kpds(5..7) parameters

	call atok5('HGT',idx)
	call atok5('HGT',idy)
	call atok5('PRES',newid)

	if (idx.eq.-1.or.idy.eq.-1.or.newid.eq.-1) then
	    write(*,*) 'illegal variable name'
	    call exit(8)
	endif

	call setlev(kpdsx,kgdsx,1000.0)
	kpdsx6=kpdsx(6)
	kpdsx7=kpdsx(7)
	call setlev(kpdsy,kgdsy,500.0)
	kpdsy6=kpdsy(6)
	kpdsy7=kpdsy(7)
c	mean sea level
	kpdsz6 = 102
	kpdsz7 = 0
	levelz = -102.0
	icount = 0

c	*** read index file ***
	inumx = 0
	inumy = 0

250	read(54,*,end=500) time
	write(*,*) 'time=',time
	    if (time.le.0) goto 500

	    time2 = time
	    hour = mod(time,100)
	    time = time/100
	    day = mod(time,100)
	    time = time/100
	    mon = mod(time,100)
	    time = time/100
	    year = mod(time,10000)

            do 260 i = 1, 100
                kpdsx(i) = -1
                kpdsy(i) = -1
260         continue
            kpdsx(5) = idx
            kpdsx(6) = kpdsx6
            kpdsx(7) = kpdsx7
            kpdsx(8) = mod(year-1,100)+1
            kpdsx(21) = (year-kpdsx(8))/100 + 1
            kpdsx(9) = mon
            kpdsx(10) = day
            kpdsx(11) = hour
 
            kpdsy(5) = idy
            kpdsy(6) = kpdsy6
            kpdsy(7) = kpdsy7
            kpdsy(8) = mod(year-1,100)+1
            kpdsy(21) = (year-kpdsy(8))/100 + 1
            kpdsy(9) = mon
            kpdsy(10) = day
            kpdsy(11) = hour

	write(*,*) '>>pdscan'
            call pdscan(51,kpdsx,inumx,offsetx,reclx)
            if (reclx.eq.0) then
                write(*,*) 'missing x, time ', time2
		call exit(8)
                goto 250
            endif

	write(*,*) '>>pdscab'
            call pdscab(53,kpdsy,inumy,offsety,recly)
            if (recly.eq.0) then
                write(*,*) 'missing y, time ', time2
		call exit(8)
                goto 250
            endif

	write(*,*) '>>rdgb1'
            call rdgb(50,reclx,offsetx,kpdsx,kgdsx,n,lbmsx,z1000)
	write(*,*) '>>rdgb2'
            call rdgb(52,recly,offsety,kpdsy,kgdsy,n,lbmsy,z500)

	    call getbit(kpdsx, kgdsx, hasbtx)
	    call getbit(kpdsy, kgdsy, hasbty)

	    nx = kgdsx(2)
	    ny = kgdsx(3)
	    nxny = nx * ny
	    if (nxny.ne.kgdsy(2)*kgdsy(3)) then
		write(*,*) 'unequal dimensions!'
		call exit(8)
	    endif

	    if (hasbtx.or.hasbty) then
		write(*,*) 'expecting no bitmap - but has bitmap'
		write(*,*) ' modify code'
		call exit(8)
	    endif

	    do 450 i = 1, nxny
c		*** gdas - in mb ***
c		slp(i)=1000.0*exp(z1000(i)/
c     2			(1.5422885*(z500(i)-z1000(i))))
c		*** grib - in Pascals ***
		slp(i)=100000.0*exp(z1000(i)/
     2			(1.5422885*(z500(i)-z1000(i))))
450	    continue

c	    set center, subcenter, model
	    call setctr(kpdsx(1), kpdsx(23), kpdsx(2))

	write(*,*) '>>ezgbw1'
            call ezgbw1(slp,nx,ny,newid,.true.,levelz,
     1              year,mon,day,hour,1)


	    icount = icount + 1
	goto 250

500	continue

	write(*,*) 'no. slp fields calculated = ',icount
	if (icount.eq.0) call exit(8)
	call exit(0)
	stop
	end

	program gribrh
c
c	a program to go from rel humdity/temp to specific hum
c
c	this program is built along the lines of
c	grib_covar.f
c
c	file 50: seq grib file-x -- temp
c	file 51: index grib file-temp
c	file 52: seq grib file- rh
c	file 53: index grib file-rh
c	file 54: list of times [yyyymmddhh]
c	file 55: level
c
c	file 1: output file seq grib - specific humidity
c
c	v1.1 - dynamic sizing of precision
c
	parameter (maxv=100000)

	logical lbmsx(maxv), lbmsy(maxv)
	real datax(maxv), datay(maxv)
	integer icount

	integer kpdsx(100),kgdsx(100),reclx,offsetx
	integer kpdsy(100),kgdsy(100),recly,offsety
	integer kpdsx6, kpdsx7

	integer idx, idy, newid, time, time2, year, mon, hour, day
	real level
	logical hasbtx, hasbty

	call baopen(50,'fort.50',iret)
	if (iret.ne.0) then
	    write(*,*) 'error opening fort.50'
	    stop 7
	endif
	call baopen(51,'fort.51',iret)
	if (iret.ne.0) then
	    write(*,*) 'error opening fort.51'
	    stop 7
	endif
	call baopen(52,'fort.52',iret)
	if (iret.ne.0) then
	    write(*,*) 'error opening fort.52'
	    stop 7
	endif
	call baopen(53,'fort.53',iret)
	if (iret.ne.0) then
	    write(*,*) 'error opening fort.53'
	    stop 7
	endif

	read(55,*) level

c	find kpds(5..7) parameters

	call atok5('TMP',idx)
	call atok5('RH',idy)
	call atok5('SPFH',newid)

	if (idx.eq.-1.or.idy.eq.-1.or.newid.eq.-1) then
	    write(*,*) 'illegal variable name'
	    call exit(8)
	endif

	call setlev(kpdsx,kgdsx,level)
	kpdsx6=kpdsx(6)
	kpdsx7=kpdsx(7)

c	*** read index file ***
	inumx = 0
	inumy = 0
	icount = 0

250	read(54,*,end=500) time
	    if (time.le.0) goto 500

	    time2 = time
	    hour = mod(time,100)
	    time = time/100
	    day = mod(time,100)
	    time = time/100
	    mon = mod(time,100)
	    time = time/100
	    year = mod(time,10000)

            do 260 i = 1, 100
                kpdsx(i) = -1
                kpdsy(i) = -1
260         continue
            kpdsx(5) = idx
            kpdsx(6) = kpdsx6
            kpdsx(7) = kpdsx7
            kpdsx(8) = mod(year-1,100)+1
            kpdsx(21) = (year-kpdsx(8))/100 + 1
            kpdsx(9) = mon
            kpdsx(10) = day
            kpdsx(11) = hour
 
            kpdsy(5) = idy
            kpdsy(6) = kpdsx6
            kpdsy(7) = kpdsx7
            kpdsy(8) = mod(year-1,100)+1
            kpdsy(21) = (year-kpdsy(8))/100 + 1
            kpdsy(9) = mon
            kpdsy(10) = day
            kpdsy(11) = hour

            call pdscan(51,kpdsx,inumx,offsetx,reclx)
            if (reclx.eq.0) then
                write(*,*) 'missing x, time ', time2
		call exit(8)
                goto 250
            endif

            call pdscab(53,kpdsy,inumy,offsety,recly)
            if (recly.eq.0) then
                write(*,*) 'missing y, time ', time2
		call exit(8)
                goto 250
            endif

            call rdgb(50,reclx,offsetx,kpdsx,kgdsx,ndatax,lbmsx,datax)
            call rdgb(52,recly,offsety,kpdsy,kgdsy,ndatay,lbmsy,datay)

	    call getbit(kpdsx, kgdsx, hasbtx)
	    call getbit(kpdsy, kgdsy, hasbty)

	    nx = kgdsx(2)
	    ny = kgdsx(3)
	    nxny = nx * ny
	    if (nxny.ne.kgdsy(2)*kgdsy(3)) then
		write(*,*) 'unequal dimensions!'
		call exit(8)
	    endif

	    if (hasbtx.or.hasbty) then
		write(*,*) 'expecting no bitmap - but has bitmap'
		write(*,*) ' modify code'
		call exit(8)
	    endif

	    do 450 i = 1, nxny
		call trh2sh(datax(i),datay(i),level,shum)
	        datax(i) = shum
450	    continue

c	    old way -- fixed scaling
c           call ezgbw1(datax,nx,ny,newid,.true.,level,
c    1              year,mon,day,hour,1)

c	    new way -- find best decimal scaling factor

	    shmin = datax(1)
	    shmax = datax(1)
	    do i = 2, nxny
		shmin = amin1(shmin,datax(i))
		shmax = amax1(shmax,datax(i))
	    enddo
	    shdiff = shmax - shmin
	    iscale = 0
	    if (shdiff .eq. 0.0) then
		write(*,*) 'constant spec. humidity field'
	    else
460		if (shdiff.lt.999.9) then
		    iscale = iscale + 1
		    shdiff = shdiff * 10.0
		    goto 460
		endif

470		if (shdiff.gt.9999.9) then
		    iscale = iscale - 1
		    shdiff = shdiff * 0.1
		    goto 470
		endif
	    endif

		
	    kpdsx(5) = newid
	    kpdsx(22) = iscale
            call ezgbwk(datax,lbmsx,kpdsx,kgdsx,1)

	    icount = icount + 1
	goto 250

500	continue

	write(*,*) 'no. spec hum fields calculated = ',icount
	if (icount.eq.0) call exit(8)
	call exit(0)
	stop
	end

c
c	added variance as a type
c
c=================================================================
c
c	change center/model id (in common block)
c
	subroutine setctr(ictr, isctr, imodel)
c
	integer ictr, isctr, imodel
	integer center, subcen, model
	common /gribc/center, subcen, model
	center = ictr
	subcen = isctr
	model = imodel
	return
	end
c=================================================================
c
	block data gribitc
	integer center, subcen, model
	common /gribc/center, subcen, model
c	nmc
	data center/7/
c	reanalysis
	data subcen/1/
c	who knows
	data model/80/
	end
c
c=================================================================
	subroutine ezgbw1(data,nx,ny,iparm,islola,level,
     2	iyear,imonth,iday,ihour,iunit)
c
c
c	ez grib write 1			W. Ebisuzaki
c
c	sets many defaults - so you don't have to 
c		lola - grid,  gaussian (future)
c	writes only 1 field that is for an instantaneous time
c
c
c	real data(nx,ny)	- data to written as grib record
c	integer iparm		- grib parameter number ex. 33 -> U wind
c	logical islola		- .true. -> lola  .false. -> gaussian grid
c	real level		- 0.0 -> 1.0 (sigma), 1.+ ->2000 (prs)
c				  -1 -> surface
c
c
	real data(nx,ny), level
	integer iparm,iyear,imonth,iday,ihour,iunit
	logical islola, ldummy(1)

	call ezgbw(data,nx,ny,ldummy,.false.,iparm,islola,level,
     2	iyear,imonth,iday,ihour,iunit,0,0,'hour','inst')

	return
	end

c=================================================================
	subroutine ezgbw2(data,nx,ny,iparm,islola,level,
     2	iyear,imonth,iday,ihour,iunit,itime1,itime2,timeun,type)
c
c	ez grib write 2			W. Ebisuzaki
c
c	sets many defaults - so you don't have to 
c		lola - grid,  gaussian (future)
c	writes only 1 field that is for a time average/accumulation/inst
c
c
	real data(nx,ny), level
	integer iparm,iyear,imonth,iday,ihour,iunit
	logical islola, ldummy(1)
	integer itime1,itime2
	character*(*) timeun,type

	call ezgbw(data,nx,ny,ldummy,.false., iparm,islola,level,
     2	iyear,imonth,iday,ihour,iunit,itime1,itime2,timeun,type)
	return
	end
c=================================================================
	subroutine ezgbw(data,nx,ny,bit,hasbit,iparm,islola,level,
     2	iyear,imonth,iday,ihour,iunit,itime1,itime2,timeun,type)
c
c
c	ez grib write 				W. Ebisuzaki
c
c	sets many defaults - so you don't have to 
c		lola - grid,  gaussian (future)
c
c	real data(nx,ny)	- data to written as grib record
c	logical bit(*), hasbit  - bitmap of defined values
c	integer iparm		- grib parameter number ex. 33 -> U wind
c	logical islola		- .true. -> lola  .false. -> gaussian grid
c	real level		- 0.0 -> 1.0 (sigma), 1.+ ->2000 (prs)
c				  -1 -> surface
c	integer itime1, itime2	- time average from time1 to time2
c	character*(*) timeun	- 'hour', 'day', 'month'
c	character*(*) type	- 'ave', 'acc', 'inst', 'climo', 'var'
c
c note: type='climo'
c	itime1 = length of mean
c	itime2 = number of years of data
c
	parameter (ilpds=28)
	parameter (mxbit=16)
	parameter (iptv=2)
	parameter (mxnxny=384*190)
c	parameter (ngrib = 100 + ilpds + mxnxny*(mxbit+1)/8+10)
	parameter (ngrib= 1000 + ilpds + mxnxny*(mxbit+1)/8)

	real data(nx,ny), level
	character*1 grib(ngrib)
	integer iyear, imonth, iday, ihour
	character*(*) timeun, type
	logical hasbit, bit(*)

	integer levelt, level1, level2, itime1, itime2
	integer iftu, time1, time2, timerg, nave, nmiss
	integer dscale(255)

	integer gridty, lengrb
	logical init, islola

        integer center, subcen, model
        common /gribc/center, subcen, model

	data init/.false./

	save init, dscale

	if (nx*ny.gt.mxnxny) then
	    write(*,*) '**************'
	    write(*,*) '*** ezgbwr ***'
	    write(*,*) 'array too small: edit, recompile'
	    write(*,*) '*** Fatal Error ***'
	    call exit(99)
	    stop
	endif

	if (.not.init) then
	    call idsdef(iptv,dscale)
	    init = .true.
	endif

	nave = 0
	nmiss = 0

c	gridtyp 0 -> lola   4 -> gaussian grid
	gridty = 0
	if (.not.islola) gridty = 4

c	set colatitude
	if (.not.islola) then
	    if (ny.eq.94) then
c		T62 Gaussian lat
	        colat1 = (90.0-88.542)*3.141592654/180.0
	    elseif (ny.eq.190) then
c		T126 Gaussian lat
	        colat1 = (90.0-89.227)*3.141592654/180.0
	    else
		write(*,*) '*** Missing Gaussian colat in gribit ***'
		write(*,*) '*** please add ***'
		write(*,*) '*** 0 used ***'
	        colat1 = 0.0
	    endif
	endif

c	set level
	level1 = 0
	if (level.ge.2000.0) then
c	    meters above ground - 2000
	    level2 = level - 2000.0
	    levelt = 105
	elseif (level.gt.1.0) then
c	    must be pressure level
	    level2 = level
	    levelt = 100
	elseif (level.ge.0.0 .and. level.le.1.0) then
c	    must be sigma level
	    level2 = 10000.0 * level
	    levelt = 107
	elseif (level.eq.-1.0) then
c	    must be the surface
	    level2 = 0
	    levelt = 1
	elseif (level.gt.-256.0.and.level.lt.-1.0) then
	    rlevel = -level
	    levelt = int(rlevel)

            if (levelt.le.100.or.levelt.eq.102.or.levelt.eq.103 .or.
     1            levelt.eq.105.or.levelt.eq.107.or.levelt.eq.109 .or.
     1            levelt.eq.111.or.levelt.eq.113.or.levelt.eq.125 .or.
     1            levelt.eq.160.or.levelt.eq.200.or.levelt.eq.201) then
                level1 = 0
	        level2 = int(1000*(rlevel - int(rlevel)) + 0.5)
	    else
	        level2 = int(1000*(rlevel - int(rlevel)) + 0.5)
	        level1 = level2 / 256
	        level2 = mod(level2,256)
            endif

	else if (level.eq.-257.0) then
c	    sigma 0..1
	    levelt = 108
	    level2 = 100
	else
c	    ????
	    write(*,*) 'ezgbw2: unknown level?', level
	    call exit(99)
	    stop
	endif

c	for an average/accum.
	if (timeun.eq.'hour'.or.timeun.eq.'HOUR') then
	    iftu = 1
	elseif (timeun.eq.'day'.or.timeun.eq.'DAY') then
	    iftu = 2
	elseif (timeun.eq.'month'.or.timeun.eq.'MONTH') then
	    iftu = 3
	elseif (timeun.eq.'year'.or.timeun.eq.'YEAR') then
	    iftu = 4
	    write(*,*) 'ezwgb: check year parameter!!'
	    stop
	else
	    write(*,*) 'ezwgb timeun:',timeun
	    call exit(99)
	endif

	if (type.eq.'inst'.or.type.eq.'INST'.or.itime1.eq.itime2) then
	    timerg = 10
	    time1 = 0
	    time2 = min0(itime1, itime2)
	else if (type.eq.'acc'.or.type.eq.'ACC') then
	    timerg = 4
	    time1 = min0(itime1, itime2)
	    time2 = max0(itime1, itime2)
	else if (type.eq.'ave'.or.type.eq.'AVE') then
	    timerg = 3
	    time1 = min0(itime1, itime2)
	    time2 = max0(itime1, itime2)
	else if (type.eq.'climo'.or.type.eq.'CLIMO') then
c	    time1 = length of average
c	    time2 = number of years of data
	    timerg = 51
	    time1 = 0
	    time2 = itime1
	    nave = itime2
	else if (type.eq.'var'.or.type.eq.'VAR') then
	    timerg = 118
	    time1 = min0(itime1, itime2)
	    time2 = max0(itime1, itime2)
	else
	     write(*,*) 'ezwgb2 type:',type
	     call exit(99)
	endif

	ids = dscale(iparm)
	if (type.eq.'var'.or.type.eq.'VAR') ids = 2*ids

c	bitmap?
	ibms = 0
	if (hasbit) ibms = 1

	call gribit(data,bit,gridty,nx,ny,mxbit,colat1,ilpds,
     1		iptv,center,subcen,model,ibms,iparm,
     2		levelt, level1, level2,
     3		iyear, imonth, iday, ihour, 
     4		iftu, time1, time2, timerg,
     5		nave, nmiss, ids, grib, lengrb, ierr)

	if (ierr.eq.0) call binwrt(iunit, grib, lengrb)

	return
	end
c
c=====================================================================
c
	subroutine ezgbwk(data,lbm,kpds,kgds,iunit)
c
c	write grib record, kpds, kgds must be defined by caller
c
	parameter (mxbit=16)
	parameter (ilpds = 28)
	parameter (mxnxny=384*190)
c	parameter (ngrib = 100 + ilpds + mxnxny*(mxbit+1)/8+10)
	parameter (ngrib= 1000 + ilpds + mxnxny*(mxbit+1)/8)

	real data(*)
	logical lbm(*)
	integer kpds(*), kgds(*)
	integer center, subcen, model
	character*1 grib(ngrib)

c	data(nx,ny) -- data to write

c	lbm(nx,ny) -- optional bitmap

c	lola/gaussian
	idrt = kgds(1)

c	dim of data(nx,ny)
	nx = kgds(2)
	ny = kgds(3)

c	maximum number of bits

c	colatitude
c	colat1 = (90e3 - (kpds(6)))*acos(-1.0)/(180e3)
	colat1 = (90e3 - (kgds(4)))*acos(-1.0)/(180e3)

c	length of pds (usually 28)
c	ilpds

c	parameter table (usually 1)
	iptv = kpds(19)
c	forecast center
	center = kpds(1)
c	subcenter
	subcen = kpds(23)
c	generating model
	model = kpds(2)
c	has bitmap?
	ibms = mod(kpds(4)/64,2)
	write(*,*) 'ezgbwk1 ibms=',ibms

c	input parameter
	ipu = kpds(5)

c	level indicator
	itl=kpds(6)
c	old code
c        if(itl.LE.100.OR.itl.EQ.102.OR.itl.EQ.103.OR.
c     &    itl.EQ.105.OR.itl.EQ.107.OR.itl.EQ.111.OR.
c     &    itl.EQ.160)  then
c	mod 2/28/95
	if (itl.le.100 .or. itl.eq.102 .or. itl.eq.103 .or.
     1		itl.eq.105 .or. itl.eq.107 .or. itl.eq.109 .or.
     1		itl.eq.111 .or. itl.eq.113 .or. itl.eq.125 .or.
     1		itl.eq.160 .or. itl.eq.200 .or. itl.eq.201) then

            il1=0
            il2=kpds(7)
        else
            il1=mod(kpds(7)/256,256)
            il2=mod(kpds(7),256)
        endif

c	date
c	iyr = kpds(8)
	iyr = kpds(8) + (kpds(21)-1)*100

	imo = kpds(9)
	idy = kpds(10)
	ihr = kpds(11)
c	forecast unit, and times, and units
	iftu = kpds(13)
	ip1 = kpds(14)
	ip2 = kpds(15)
	itr = kpds(16)

c	number in/missing from average
	ina = kpds(17)
	inm = kpds(20)
c	integer decimal scaling
	ids = kpds(22)

c	write(*,*) 'idrt=',idrt,' nx/ny=',nx,ny,' mxbit=',mxbit
c	write(*,*) 'colat1=',colat1,' ilpds=',ilpds,' iptv=',iptv
c	write(*,*) 'icen=',icen,' igen=',igen,' ibms=',ibms,' param=',ipu
c	write(*,*) 'times:',itl,il1,il2
c	write(*,*) 'date:',iyr,imo,idy,ihr
c	write(*,*) 'forcast times:',iftu,ip1,ip2,itr
c	write(*,*) 'no. for ave=',ina,' missing=',inm,' dec scale=',ids
	call gribit(data,lbm,idrt,nx,ny,mxbit,colat1,ilpds,iptv,
     a      center,subcen,model,
     1	    ibms,ipu,itl,il1,il2,iyr,imo,idy,ihr,iftu,ip1,ip2,itr,
     2	    ina,inm,ids,grib,lengrb,ierr)

	if (ierr.eq.0) call binwrt(iunit, grib, lengrb)

	return
	end
c=====================================================================
	subroutine binwrt(iunit,string,n)
c
c	binary write
c
	character*1 string(n)
	write(*,*) '>> binwrt'
	write(iunit) string
	return
	end
c=====================================================================
CFPP$ NOCONCUR R
      SUBROUTINE GRIBIT(F,LBM,IDRT,IM,JM,MXBIT,COLAT1,
     &                  ILPDS,IPTV,ICEN,ISUBCN,IGEN,IBMS,IPU,ITL,
     &                  IL1,IL2,
     &                  IYR,IMO,IDY,IHR,IFTU,IP1,IP2,ITR,INA,INM,IDS,
     &                  GRIB,LGRIB,IERR)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    GRIBIT      CREATE GRIB MESSAGE
C   PRGMMR: IREDELL          ORG: W/NMC23    DATE: 92-10-31
C
C ABSTRACT: CREATE A GRIB MESSAGE FROM A FULL FIELD.
C   AT PRESENT, ONLY GLOBAL LATLON GRIDS AND GAUSSIAN GRIDS ARE ALLOWED.
C
C PROGRAM HISTORY LOG:
C   92-10-31  IREDELL
C
C USAGE:    CALL GRIBIT(F,LBM,IDRT,IM,JM,MXBIT,COLAT1,
C    &                  ILPDS,IPTV,ICEN,IGEN,IBMS,IPU,ITL,IL1,IL2,
C    &                  IYR,IMO,IDY,IHR,IFTU,IP1,IP2,ITR,INA,INM,IDS,
C    &                  GRIB,LGRIB,IERR)
C   INPUT ARGUMENT LIST:
C     F        - REAL (IM*JM) FIELD DATA TO PACK INTO GRIB MESSAGE
C     LBM      - LOGICAL (IM*JM) BITMAP TO USE IF IBMS=1
C     IDRT     - INTEGER DATA REPRESENTATION TYPE
C                (0 FOR LATLON OR 4 FOR GAUSSIAN)
C     IM       - INTEGER LONGITUDINAL DIMENSION
C     JM       - INTEGER LATITUDINAL DIMENSION
C     MXBIT    - INTEGER MAXIMUM NUMBER OF BITS TO USE (0 FOR NO LIMIT)
C     COLAT1   - REAL FIRST COLATITUDE OF GAUSSIAN GRID IF IDRT=4
C     ILPDS    - INTEGER LENGTH OF THE PDS (USUALLY 28)
C     IPTV     - INTEGER PARAMETER TABLE VERSION (USUALLY 1)
C     ICEN     - INTEGER FORECAST CENTER (USUALLY 7)
C     ISUBCN   - INTEGER SUBCENTER
C     IGEN     - INTEGER MODEL GENERATING CODE
C     IBMS     - INTEGER BITMAP FLAG (0 FOR NO BITMAP)
C     IPU      - INTEGER PARAMETER AND UNIT INDICATOR
C     ITL      - INTEGER TYPE OF LEVEL INDICATOR
C     IL1      - INTEGER FIRST LEVEL VALUE (0 FOR SINGLE LEVEL)
C     IL2      - INTEGER SECOND LEVEL VALUE
C    &                  IYR,IMO,IDY,IHR,IFTU,IP1,IP2,ITR,INA,INM,IDS,
C    &                  GRIB,LGRIB,IERR)
C     IYR      - INTEGER YEAR (YYYY)
C     IMO      - INTEGER MONTH
C     IDY      - INTEGER DAY
C     IHR      - INTEGER HOUR
C     IFTU     - INTEGER FORECAST TIME UNIT (1 FOR HOUR)
C     IP1      - INTEGER FIRST TIME PERIOD
C     IP2      - INTEGER SECOND TIME PERIOD (0 FOR SINGLE PERIOD)
C     ITR      - INTEGER TIME RANGE INDICATOR (10 FOR SINGLE PERIOD)
C     INA      - INTEGER NUMBER INCLUDED IN AVERAGE
C     INM      - INTEGER NUMBER MISSING FROM AVERAGE
C     IDS      - INTEGER DECIMAL SCALING
C
C   OUTPUT ARGUMENT LIST:
C     GRIB     - CHARACTER (LGRIB) GRIB MESSAGE
C     LGRIB    - INTEGER LENGTH OF GRIB MESSAGE
C                (NO MORE THAN 100+ILPDS+IM*JM*(MXBIT+1)/8)
C     IERR     - INTEGER ERROR CODE (0 FOR SUCCESS)
C
C SUBPROGRAMS CALLED:
C   GTBITS     - COMPUTE NUMBER OF BITS AND ROUND DATA APPROPRIATELY
C   W3FI72     - ENGRIB DATA INTO A GRIB1 MESSAGE
C
C ATTRIBUTES:
C   LANGUAGE: CRAY FORTRAN
C
C$$$
      REAL F(IM*JM)
      LOGICAL LBM(IM*JM)
      CHARACTER GRIB(*)
      INTEGER IBM(IM*JM*IBMS+1-IBMS),IPDS(25),IGDS(18),IBDS(9)
      REAL FR(IM*JM)
      CHARACTER PDS(ILPDS)
c	write(*,*) '>>gribit'
      NF=IM*JM
      LONI=NINT(360.E3/IM)
      IF(IDRT.EQ.0) THEN
        LAT1=NINT(90.E3)
        LATI=NINT(180.E3/(JM-1))
        IF(IM.EQ.144.AND.JM.EQ.73) THEN
          IGRID=2
        ELSEIF(IM.EQ.360.AND.JM.EQ.181) THEN
          IGRID=3
        ELSE
          IGRID=255
        ENDIF
      ELSEIF(IDRT.EQ.4) THEN
        LAT1=NINT(90.E3-180.E3/ACOS(-1.)*COLAT1)
        LATI=JM/2
        IGRID=255
      ELSE
        IERR=40
        RETURN
      ENDIF
      IPDS(01)=ILPDS    ! LENGTH OF PDS
      IPDS(02)=IPTV     ! PARAMETER TABLE VERSION ID
      IPDS(03)=ICEN     ! CENTER ID
      IPDS(04)=IGEN     ! GENERATING MODEL ID
      IPDS(05)=IGRID    ! GRID ID
      IPDS(06)=1        ! GDS FLAG
      IPDS(07)=IBMS     ! BMS FLAG
      IPDS(08)=IPU      ! PARAMETER UNIT ID
      IPDS(09)=ITL      ! TYPE OF LEVEL ID
      IPDS(10)=IL1      ! LEVEL 1 OR 0
      IPDS(11)=IL2      ! LEVEL 2
c     IPDS(12)=IYR      ! YEAR
      IPDS(12)=mod((IYR-1),100) + 1
      IPDS(13)=IMO      ! MONTH
      IPDS(14)=IDY      ! DAY
      IPDS(15)=IHR      ! HOUR
      IPDS(16)=0        ! MINUTE
      IPDS(17)=IFTU     ! FORECAST TIME UNIT ID
      IPDS(18)=IP1      ! TIME PERIOD 1
      IPDS(19)=IP2      ! TIME PERIOD 2 OR 0
      IPDS(20)=ITR      ! TIME RANGE INDICATOR
      IPDS(21)=INA      ! NUMBER IN AVERAGE
      IPDS(22)=INM      ! NUMBER MISSING
c     IPDS(23)=20       ! CENTURY
      IPDS(23)=((IYR-IPDS(12))/100) + 1
      IPDS(24)=ISUBCN   ! SUBCENTER
      IPDS(25)=IDS      ! DECIMAL SCALING
      IGDS(01)=0        ! NUMBER OF VERTICAL COORDS
      IGDS(02)=255      ! VERTICAL COORD FLAG
      IGDS(03)=IDRT     ! DATA REPRESENTATION TYPE
      IGDS(04)=IM       ! EAST-WEST POINTS
      IGDS(05)=JM       ! NORTH-SOUTH POINTS
      IGDS(06)=LAT1     ! LATITUDE OF ORIGIN
      IGDS(07)=0        ! LONGITUDE OF ORIGIN
      IGDS(08)=128      ! RESOLUTION FLAG
      IGDS(09)=-LAT1    ! LATITUDE OF END
      IGDS(10)=-LONI    ! LONGITUDE OF END
      IGDS(11)=LATI     ! LAT INCREMENT OR GAUSSIAN LATS
      IGDS(12)=LONI     ! LONGITUDE INCREMENT
      IGDS(13)=0        ! SCANNING MODE FLAGS
c     IGDS(14:18)=0     ! NOT USED
	call ifill(igds(14),5,0)
c     IBDS(1:9)=0       ! BDS FLAGS
	call ifill(ibds,9,0)

      NBM=NF
c	write(*,*) 'gribit:ibms=',ibms
      IF(IBMS.NE.0) THEN
        NBM=0
        DO I=1,NF
          IF(LBM(I)) THEN
            IBM(I)=1
            NBM=NBM+1
          ELSE
            IBM(I)=0
          ENDIF
        ENDDO
        IF(NBM.EQ.NF) IPDS(7)=0
      ENDIF
c	write(*,*) 'gribit2 nbm=',nbm
      IF(NBM.EQ.0) THEN
        DO I=1,NF
          FR(I)=0.
        ENDDO
        NBIT=0
      ELSE
c	write(*,*)'gribit3 ipds(7)=',ipds(7),' ids=', ids
c	write(*,*) 'f(1), fr(1)=',f(1),fr(1),' nbit=',nbit
c	write(*,*) 'nf=#=',nf
	fmin = f(1)
	fmax = fmin
	do ii = 1, nf
	    fmin = amin1(fmin,f(ii))
	    fmax = amax1(fmax,f(ii))
	enddo
c	write(*,*) 'fmin/fmax=',fmin,fmax

        CALL GTBITS(IPDS(7),IDS,NF,IBM,F,FR,FMIN,FMAX,NBIT)
c	write(*,*) 'fmin/max=',fmin,fmax,' nbit=',nbit
        IF(MXBIT.GT.0) NBIT=MIN(NBIT,MXBIT)
      ENDIF
c	write(*,*)'gribit4'
      CALL W3FI72(0,FR,0,NBIT,0,IPDS,PDS,
     &            1,255,IGDS,0,0,IBM,NF,IBDS,
     &            NFO,GRIB,LGRIB,IERR)
c	write(*,*)'gribit5'
      RETURN
      END

CFPP$ NOCONCUR R
      SUBROUTINE GTBITS(IBM,IDS,LEN,MG,G,GROUND,GMIN,GMAX,NBIT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:    GTBITS      COMPUTE NUMBER OF BITS AND ROUND FIELD.
C   PRGMMR: IREDELL          ORG: W/NMC23    DATE: 92-10-31
C
C ABSTRACT: THE NUMBER OF BITS REQUIRED TO PACK A GIVEN FIELD
C   AT A PARTICULAR DECIMAL SCALING IS COMPUTED USING THE FIELD RANGE.
C   THE FIELD IS ROUNDED OFF TO THE DECIMAL SCALING FOR PACKING.
C   THE MINIMUM AND MAXIMUM ROUNDED FIELD VALUES ARE ALSO RETURNED.
C   GRIB BITMAP MASKING FOR VALID DATA IS OPTIONALLY USED.
C
C PROGRAM HISTORY LOG:
C   92-10-31  IREDELL
C
C USAGE:    CALL GTBITS(IBM,IDS,LEN,MG,G,GMIN,GMAX,NBIT)
C   INPUT ARGUMENT LIST:
C     IBM      - INTEGER BITMAP FLAG (=0 FOR NO BITMAP)
C     IDS      - INTEGER DECIMAL SCALING
C                (E.G. IDS=3 TO ROUND FIELD TO NEAREST MILLI-VALUE)
C     LEN      - INTEGER LENGTH OF THE FIELD AND BITMAP
C     MG       - INTEGER (LEN) BITMAP IF IBM=1 (0 TO SKIP, 1 TO KEEP)
C     G        - REAL (LEN) FIELD
C
C   OUTPUT ARGUMENT LIST:
C     GROUND   - REAL (LEN) FIELD ROUNDED TO DECIMAL SCALING
C     GMIN     - REAL MINIMUM VALID ROUNDED FIELD VALUE
C     GMAX     - REAL MAXIMUM VALID ROUNDED FIELD VALUE
C     NBIT     - INTEGER NUMBER OF BITS TO PACK
C
C SUBPROGRAMS CALLED:
C   ISRCHNE  - FIND FIRST VALUE IN AN ARRAY NOT EQUAL TO TARGET VALUE
C
C ATTRIBUTES:
C   LANGUAGE: CRAY FORTRAN
C
C$$$
      DIMENSION MG(LEN),G(LEN),GROUND(LEN)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  ROUND FIELD AND DETERMINE EXTREMES WHERE BITMAP IS ON
      DS=10.**IDS
      IF(IBM.EQ.0) THEN
        GROUND(1)=NINT(G(1)*DS)/DS
        GMAX=GROUND(1)
        GMIN=GROUND(1)
        DO I=2,LEN
          GROUND(I)=NINT(G(I)*DS)/DS
          GMAX=MAX(GMAX,GROUND(I))
          GMIN=MIN(GMIN,GROUND(I))
        ENDDO
      ELSE
        I1=ISRCHNE(LEN,MG,1,0)
        IF(I1.GT.0.AND.I1.LE.LEN) THEN
          GROUND(I1)=NINT(G(I1)*DS)/DS
          GMAX=GROUND(I1)
          GMIN=GROUND(I1)
          DO I=I1+1,LEN
            IF(MG(I).NE.0) THEN
              GROUND(I)=NINT(G(I)*DS)/DS
              GMAX=MAX(GMAX,GROUND(I))
              GMIN=MIN(GMIN,GROUND(I))
            ENDIF
          ENDDO
        ELSE
          GMAX=0.
          GMIN=0.
        ENDIF
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  COMPUTE NUMBER OF BITS
      NBIT=LOG((GMAX-GMIN)*DS+0.9)/LOG(2.)+1.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      RETURN
      END

      SUBROUTINE IDSDEF(IPTV,IDS)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: IDSDEF         SETS DEFAULT DECIMAL SCALINGS
C   PRGMMR: IREDELL          ORG: W/NMC23     DATE: 92-10-31
C
C ABSTRACT: SETS DECIMAL SCALINGS DEFAULTS FOR VARIOUS PARAMETERS.
C   A DECIMAL SCALING OF -3 MEANS DATA IS PACKED IN KILO-SI UNITS.
C
C PROGRAM HISTORY LOG:
C   92-10-31  IREDELL
C
C USAGE:    CALL IDSDEF(IPTV,IDS)
C   INPUT ARGUMENTS:
C     IPTV         PARAMTER TABLE VERSION (ONLY 1 OR 2 IS RECOGNIZED)
C   OUTPUT ARGUMENTS:
C     IDS          INTEGER (255) DECIMAL SCALINGS
C                  (UNKNOWN DECIMAL SCALINGS WILL NOT BE SET)
C
C ATTRIBUTES:
C   LANGUAGE: CRAY FORTRAN
C
C$$$
      DIMENSION IDS(255)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      IF(IPTV.EQ.1.OR.IPTV.EQ.2) THEN
        IDS(001)=-1     ! PRESSURE (PA)
        IDS(002)=-1     ! SEA-LEVEL PRESSURE (PA)
        IDS(003)=5      ! PRESSURE TENDENCY (PA/S)
                        !
                        !
        IDS(006)=-1     ! GEOPOTENTIAL (M2/S2)
        IDS(007)=0      ! GEOPOTENTIAL HEIGHT (M)
        IDS(008)=0      ! GEOMETRIC HEIGHT (M)
        IDS(009)=0      ! STANDARD DEVIATION OF HEIGHT (M)
                        !
        IDS(011)=1      ! TEMPERATURE (K)
        IDS(012)=1      ! VIRTUAL TEMPERATURE (K)
        IDS(013)=1      ! POTENTIAL TEMPERATURE (K)
        IDS(014)=1      ! PSEUDO-ADIABATIC POTENTIAL TEMPERATURE (K)
        IDS(015)=1      ! MAXIMUM TEMPERATURE (K)
        IDS(016)=1      ! MINIMUM TEMPERATURE (K)
        IDS(017)=1      ! DEWPOINT TEMPERATURE (K)
        IDS(018)=1      ! DEWPOINT DEPRESSION (K)
        IDS(019)=4      ! TEMPERATURE LAPSE RATE (K/M)
        IDS(020)=0      ! VISIBILITY (M)
                        ! RADAR SPECTRA 1 ()
                        ! RADAR SPECTRA 2 ()
                        ! RADAR SPECTRA 3 ()
                        !
        IDS(025)=1      ! TEMPERATURE ANOMALY (K)
        IDS(026)=-1     ! PRESSURE ANOMALY (PA)
        IDS(027)=0      ! GEOPOTENTIAL HEIGHT ANOMALY (M)
                        ! WAVE SPECTRA 1 ()
                        ! WAVE SPECTRA 2 ()
                        ! WAVE SPECTRA 3 ()
        IDS(031)=0      ! WIND DIRECTION (DEGREES)
        IDS(032)=1      ! WIND SPEED (M/S)
        IDS(033)=1      ! ZONAL WIND (M/S)
        IDS(034)=1      ! MERIDIONAL WIND (M/S)
        IDS(035)=-4     ! STREAMFUNCTION (M2/S) WNE
        IDS(036)=-4     ! VELOCITY POTENTIAL (M2/S) WNE
        IDS(037)=-1     ! MONTGOMERY STREAM FUNCTION (M2/S2)
        IDS(038)=8      ! SIGMA VERTICAL VELOCITY (1/S)
        IDS(039)=3      ! PRESSURE VERTICAL VELOCITY (PA/S)
        IDS(040)=4      ! GEOMETRIC VERTICAL VELOCITY (M/S)
        IDS(041)=6      ! ABSOLUTE VORTICITY (1/S)
        IDS(042)=6      ! ABSOLUTE DIVERGENCE (1/S)
        IDS(043)=6      ! RELATIVE VORTICITY (1/S)
        IDS(044)=6      ! RELATIVE DIVERGENCE (1/S)
        IDS(045)=4      ! VERTICAL U SHEAR (1/S)
        IDS(046)=4      ! VERTICAL V SHEAR (1/S)
        IDS(047)=0      ! DIRECTION OF CURRENT (DEGREES)
                        ! SPEED OF CURRENT (M/S)
                        ! U OF CURRENT (M/S)
                        ! V OF CURRENT (M/S)
        IDS(051)=4      ! SPECIFIC HUMIDITY (KG/KG)
        IDS(052)=0      ! RELATIVE HUMIDITY (PERCENT)
        IDS(053)=4      ! HUMIDITY MIXING RATIO (KG/KG)
        IDS(054)=1      ! PRECIPITABLE WATER (KG/M2)
        IDS(055)=-1     ! VAPOR PRESSURE (PA)
        IDS(056)=-1     ! SATURATION DEFICIT (PA)
        IDS(057)=1      ! EVAPORATION (KG/M2)
        IDS(058)=1      ! CLOUD ICE (KG/M2)
        IDS(059)=6      ! PRECIPITATION RATE (KG/M2/S)
        IDS(060)=0      ! THUNDERSTORM PROBABILITY (PERCENT)
        IDS(061)=1      ! TOTAL PRECIPITATION (KG/M2)
        IDS(062)=1      ! LARGE-SCALE PRECIPITATION (KG/M2)
        IDS(063)=1      ! CONVECTIVE PRECIPITATION (KG/M2)
        IDS(064)=6      ! WATER EQUIVALENT SNOWFALL RATE (KG/M2/S)
        IDS(065)=0      ! WATER EQUIVALENT OF SNOW DEPTH (KG/M2)
        IDS(066)=2      ! SNOW DEPTH (M)
                        ! MIXED-LAYER DEPTH (M)
                        ! TRANSIENT THERMOCLINE DEPTH (M)
                        ! MAIN THERMOCLINE DEPTH (M)
                        ! MAIN THERMOCLINE ANOMALY (M)
        IDS(071)=0      ! TOTAL CLOUD COVER (PERCENT)
        IDS(072)=0      ! CONVECTIVE CLOUD COVER (PERCENT)
        IDS(073)=0      ! LOW CLOUD COVER (PERCENT)
        IDS(074)=0      ! MIDDLE CLOUD COVER (PERCENT)
        IDS(075)=0      ! HIGH CLOUD COVER (PERCENT)
        IDS(076)=1      ! CLOUD WATER (KG/M2)
                        !
        IDS(078)=1      ! CONVECTIVE SNOW (KG/M2)
        IDS(079)=1      ! LARGE SCALE SNOW (KG/M2)
        IDS(080)=1      ! WATER TEMPERATURE (K)
        IDS(081)=0      ! SEA-LAND MASK ()
                        ! DEVIATION OF SEA LEVEL FROM MEAN (M)
        IDS(083)=5      ! ROUGHNESS (M)
        IDS(084)=0      ! ALBEDO (PERCENT)
        IDS(085)=1      ! SOIL TEMPERATURE (K)
        IDS(086)=0      ! SOIL WETNESS (KG/M2)
        IDS(087)=0      ! VEGETATION (PERCENT)
                        ! SALINITY (KG/KG)
        IDS(089)=4      ! DENSITY (KG/M3)
        IDS(090)=1      ! RUNOFF (KG/M2)
        IDS(091)=0      ! ICE CONCENTRATION ()
                        ! ICE THICKNESS (M)
        IDS(093)=0      ! DIRECTION OF ICE DRIFT (DEGREES)
                        ! SPEED OF ICE DRIFT (M/S)
                        ! U OF ICE DRIFT (M/S)
                        ! V OF ICE DRIFT (M/S)
                        ! ICE GROWTH (M)
                        ! ICE DIVERGENCE (1/S)
        IDS(099)=1      ! SNOW MELT (KG/M2)
                        ! SIG HEIGHT OF WAVES AND SWELL (M)
        IDS(101)=0      ! DIRECTION OF WIND WAVES (DEGREES)
                        ! SIG HEIGHT OF WIND WAVES (M)
                        ! MEAN PERIOD OF WIND WAVES (S)
        IDS(104)=0      ! DIRECTION OF SWELL WAVES (DEGREES)
                        ! SIG HEIGHT OF SWELL WAVES (M)
                        ! MEAN PERIOD OF SWELL WAVES (S)
        IDS(107)=0      ! PRIMARY WAVE DIRECTION (DEGREES)
                        ! PRIMARY WAVE MEAN PERIOD (S)
        IDS(109)=0      ! SECONDARY WAVE DIRECTION (DEGREES)
                        ! SECONDARY WAVE MEAN PERIOD (S)
        IDS(111)=0      ! NET SOLAR RADIATIVE FLUX AT SURFACE (W/M2)
        IDS(112)=0      ! NET LONGWAVE RADIATIVE FLUX AT SURFACE (W/M2)
        IDS(113)=0      ! NET SOLAR RADIATIVE FLUX AT TOP (W/M2)
        IDS(114)=0      ! NET LONGWAVE RADIATIVE FLUX AT TOP (W/M2)
        IDS(115)=0      ! NET LONGWAVE RADIATIVE FLUX (W/M2)
        IDS(116)=0      ! NET SOLAR RADIATIVE FLUX (W/M2)
        IDS(117)=0      ! TOTAL RADIATIVE FLUX (W/M2)
                        !
                        !
                        !
        IDS(121)=0      ! LATENT HEAT FLUX (W/M2)
        IDS(122)=0      ! SENSIBLE HEAT FLUX (W/M2)
        IDS(123)=0      ! BOUNDARY LAYER DISSIPATION (W/M2)
        IDS(124)=3      ! U WIND STRESS (N/M2)
        IDS(125)=3      ! V WIND STRESS (N/M2)
                        ! WIND MIXING ENERGY (J)
                        ! IMAGE DATA ()
        IDS(128)=-1     ! MEAN SEA-LEVEL PRESSURE (STDATM) (PA)
        IDS(129)=-1     ! MEAN SEA-LEVEL PRESSURE (MAPS) (PA)
        IDS(130)=-1     ! MEAN SEA-LEVEL PRESSURE (ETA) (PA)
        IDS(131)=1      ! SURFACE LIFTED INDEX (K)
        IDS(132)=1      ! BEST LIFTED INDEX (K)
        IDS(133)=1      ! K INDEX (K)
        IDS(134)=1      ! SWEAT INDEX (K)
        IDS(135)=10     ! HORIZONTAL MOISTURE DIVERGENCE (KG/KG/S)
        IDS(136)=4      ! SPEED SHEAR (1/S)
        IDS(137)=5      ! 3-HR PRESSURE TENDENCY (PA/S)
        IDS(138)=6      ! BRUNT-VAISALA FREQUENCY SQUARED (1/S2)
        IDS(139)=11     ! POTENTIAL VORTICITY (MASS-WEIGHTED) (1/S/M)
        IDS(140)=0      ! RAIN MASK ()
        IDS(141)=0      ! FREEZING RAIN MASK ()
        IDS(142)=0      ! ICE PELLETS MASK ()
        IDS(143)=0      ! SNOW MASK ()
                        !
                        !
                        !
                        !
                        !
                        !
                        ! COVARIANCE BETWEEN V AND U (M2/S2)
                        ! COVARIANCE BETWEEN U AND T (K*M/S)
                        ! COVARIANCE BETWEEN V AND T (K*M/S)
                        !
                        !
        IDS(155)=0      ! GROUND HEAT FLUX (W/M2)
        IDS(156)=0      ! CONVECTIVE INHIBITION (W/M2)
                        ! CONVECTIVE APE (J/KG)
                        ! TURBULENT KE (J/KG)
                        ! CONDENSATION PRESSURE OF LIFTED PARCEL (PA)
        IDS(160)=0      ! CLEAR SKY UPWARD SOLAR FLUX (W/M2)
        IDS(161)=0      ! CLEAR SKY DOWNWARD SOLAR FLUX (W/M2)
        IDS(162)=0      ! CLEAR SKY UPWARD LONGWAVE FLUX (W/M2)
        IDS(163)=0      ! CLEAR SKY DOWNWARD LONGWAVE FLUX (W/M2)
        IDS(164)=0      ! CLOUD FORCING NET SOLAR FLUX (W/M2)
        IDS(165)=0      ! CLOUD FORCING NET LONGWAVE FLUX (W/M2)
        IDS(166)=0      ! VISIBLE BEAM DOWNWARD SOLAR FLUX (W/M2)
        IDS(167)=0      ! VISIBLE DIFFUSE DOWNWARD SOLAR FLUX (W/M2)
        IDS(168)=0      ! NEAR IR BEAM DOWNWARD SOLAR FLUX (W/M2)
        IDS(169)=0      ! NEAR IR DIFFUSE DOWNWARD SOLAR FLUX (W/M2)
			!
        IDS(170)=3      ! old (but current as of 1/94) u-stress (n/m**2)
        IDS(171)=3      ! old (but current as of 1/94) v-stress (n/m**2)
                        !
                        !
        IDS(172)=3      ! MOMENTUM FLUX (N/M2)
        IDS(173)=0      ! MASS POINT MODEL SURFACE ()
        IDS(174)=0      ! VELOCITY POINT MODEL SURFACE ()
        IDS(175)=0      ! SIGMA LAYER NUMBER ()
        IDS(176)=2      ! LATITUDE (DEGREES)
        IDS(177)=2      ! EAST LONGITUDE (DEGREES)

        IDS(178)=2      ! UMAS wne
        IDS(179)=2      ! VMAS wne
                        !
                        !
                        !
        IDS(181)=9      ! X-GRADIENT LOG PRESSURE (1/M)
        IDS(182)=9      ! Y-GRADIENT LOG PRESSURE (1/M)
        IDS(183)=5      ! X-GRADIENT HEIGHT (M/M)
        IDS(184)=5      ! Y-GRADIENT HEIGHT (M/M)
                        !
                        !
                        !
                        !
                        !
                        !
                        !
                        !
                        !
                        !
                        !
                        !
                        !
                        !
                        !
                        !
        IDS(201)=0      ! ICE-FREE WATER SURCACE (PERCENT)
                        !
                        !
        IDS(204)=0      ! DOWNWARD SOLAR RADIATIVE FLUX (W/M2)
        IDS(205)=0      ! DOWNWARD LONGWAVE RADIATIVE FLUX (W/M2)
                        !
        IDS(207)=0      ! MOISTURE AVAILABILITY (PERCENT)
                        ! EXCHANGE COEFFICIENT (KG/M2/S)
        IDS(209)=0      ! NUMBER OF MIXED LAYER NEXT TO SFC ()
                        !
        IDS(211)=0      ! UPWARD SOLAR RADIATIVE FLUX (W/M2)
        IDS(212)=0      ! UPWARD LONGWAVE RADIATIVE FLUX (W/M2)
        IDS(213)=0      ! NON-CONVECTIVE CLOUD COVER (PERCENT)
        IDS(214)=6      ! CONVECTIVE PRECIPITATION RATE (KG/M2/S)
        IDS(215)=7      ! TOTAL DIABATIC HEATING RATE (K/S)
        IDS(216)=7      ! TOTAL RADIATIVE HEATING RATE (K/S)
        IDS(217)=7      ! TOTAL DIABATIC NONRADIATIVE HEATING RATE (K/S)
        IDS(218)=2      ! PRECIPITATION INDEX (FRACTION)
        IDS(219)=1      ! STD DEV OF IR T OVER 1X1 DEG AREA (K)
        IDS(220)=4      ! NATURAL LOG OF SURFACE PRESSURE OVER 1 KPA ()
                        !
        IDS(222)=0      ! 5-WAVE GEOPOTENTIAL HEIGHT (M)
        IDS(223)=1      ! PLANT CANOPY SURFACE WATER (KG/M2)
                        !
                        !
                        ! BLACKADARS MIXING LENGTH (M)
                        ! ASYMPTOTIC MIXING LENGTH (M)
        IDS(228)=1      ! POTENTIAL EVAPORATION (KG/M2)
        IDS(229)=0      ! SNOW PHASE-CHANGE HEAT FLUX (W/M2)
                        !
        IDS(231)=3      ! CONVECTIVE CLOUD MASS FLUX (PA/S)
        IDS(232)=0      ! DOWNWARD TOTAL RADIATION FLUX (W/M2)
        IDS(233)=0      ! UPWARD TOTAL RADIATION FLUX (W/M2)
        IDS(224)=1      ! BASEFLOW-GROUNDWATER RUNOFF (KG/M2)
        IDS(225)=1      ! STORM SURFACE RUNOFF (KG/M2)
                        !
                        !
        IDS(238)=0      ! SNOW COVER (PERCENT)
        IDS(239)=1      ! SNOW TEMPERATURE (K)
                        !
        IDS(241)=7      ! LARGE SCALE CONDENSATION HEATING RATE (K/S)
        IDS(242)=7      ! DEEP CONVECTIVE HEATING RATE (K/S)
        IDS(243)=10     ! DEEP CONVECTIVE MOISTENING RATE (KG/KG/S)
        IDS(244)=7      ! SHALLOW CONVECTIVE HEATING RATE (K/S)
        IDS(245)=10     ! SHALLOW CONVECTIVE MOISTENING RATE (KG/KG/S)
        IDS(246)=7      ! VERTICAL DIFFUSION HEATING RATE (KG/KG/S)
        IDS(247)=7      ! VERTICAL DIFFUSION ZONAL ACCELERATION (M/S/S)
        IDS(248)=7      ! VERTICAL DIFFUSION MERID ACCELERATION (M/S/S)
        IDS(249)=10     ! VERTICAL DIFFUSION MOISTENING RATE (KG/KG/S)
        IDS(250)=7      ! SOLAR RADIATIVE HEATING RATE (K/S)
        IDS(251)=7      ! LONGWAVE RADIATIVE HEATING RATE (K/S)
                        ! DRAG COEFFICIENT ()
                        ! FRICTION VELOCITY (M/S)
                        ! RICHARDSON NUMBER ()
                        !
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      RETURN
      END

c
c	various utility routines
c


	subroutine setprs(kpds, kgds, iprs)
c
c	set the pressure to iprs mb
c
	integer kpds(*), kgds(*)
	kpds(6) = 100
	kpds(7) = iprs
	return
	end

	subroutine setlev(kpds, kgds, level)
c
c	level - compatible with ezwgb, getlev
c
	integer kpds(*), kgds(*), i
	real level

	if (level.gt.256*256) then
	    i = level
	    kpds(6) = i / (256*256)
	    kpds(7) = mod(i,256*256)
	else if (level.ge.2000.0) then
c	    meters - 2000.0
	    kpds(6) = 105
	    kpds(7) = level - 2000.0
	else if (level.gt.1.0) then
c	    prs level
	    kpds(6) = 100
	    kpds(7) = level
	else if (level.ge.0 .and. level.le.1.0) then
c	    sigma level
	    kpds(6) = 107
	    kpds(7) = int(level * 10000.0 + 0.5)
	else if (level.eq.-1.0) then
c	    surface
	    kpds(6) = 1
	    kpds(7) = 0
	else if (level.le.-1.0 .and.level.gt.-256.999) then
	    rlevel = -level
	    kpds(6) = int(rlevel)
	    rlevel = 1000 * (rlevel - int(rlevel))
	    kpds(7) = int(rlevel + 0.5)
	    rlevel = rlevel - kpds(7)
	else if (level.eq.-257.0) then
c	    0 ->1 sigma
	    kpds(6) = 108
	    kpds(7) = 0*256 + 100
	else
	    write(*,*) '*** setlev - bad arg:',level
	endif
	return
	end

	subroutine set2sig(kpds, kgds, sigma1,sigma2)
c
	integer kpds(*), kgds(*)
	real sigma1, sigma2, sig1,sig2

	if (sigma1.lt.sigma2) then
	    sig1 = sigma1
	    sig2 = sigma2
	else
	    sig1 = sigma2
	    sig2 = sigma1
	endif

	kpds(6) = 108
	kpds(7) = 256*int(sig1*100+0.5) + int(sig2*100+0.5)
	return
	end

	subroutine m2lev(meters,lev)
	real meters, lev
	lev = meters + 2000.0
	return
	end
	subroutine lev2m(lev,meters)
	real meters, lev
	meters = lev - 2000.0
	return
	end

	subroutine getlev(kpds, kgds, level)
c
c	get level - compatible with ezwgb
c	0 <= x =< 1.0		sigma
c	1.0 < x < 2000  	pressure
c	2000 <= x < 256*256	meters
c	256*256 <= x		arb level
c
c	-1 = surface
c	-257 = sigma 0..1
c
c	-1 -> -255.999 -> grib level type: 1->255 (0 arguments)
c
	integer kpds(*), kgds(*)
	real level

	if (kpds(6).eq.100) then
c	    pressure
	    level = kpds(7)
	    return
	else if (kpds(6).eq.1) then
c	    surface
	    level = -1.0
	    return
	else if (kpds(6).eq.105) then
c	    meters
	    level = 2000.0 + kpds(7)
	else if (kpds(6).eq.107) then
c	    sigma
	    level = kpds(7) / 10000.0
	    return
	else if (kpds(6).eq.108) then
c	    sigma1 to sigma2
	    s1 = mod(kpds(7),256)
	    s2 = kpds(7)/256
	    if (s1.eq.100.and.s2.eq.0) then
		level = -257.0
	    else
		level = kpds(7)
	    endif
	else if (kpds(6).ge.1.and.kpds(6).le.255) then
	    if (kpds(7).lt.999) then
		level = -(kpds(6)+kpds(7)/1000.0)
	    else
		level = kpds(6)*256*256 + kpds(7)
	    endif
	else
	    level = 99999.0
	endif
	return
	end

	subroutine initnm
c
c	initializes name list
c
	character*8 names(255)
	logical init
	common /shname/names
	data init/.false./
	save init

	if (init) return
	init = .true.

	do 10 i = 1, 255
	    names(i) = 'unknown'
10	continue

	names(1) = 'P'
	names(7) = 'Z'
	names(8) = 'H'
	names(11) = 'T'
	names(12) = 'Tv'
	names(13) = 'Theta'
	names(14) = 'ThetaE'
	names(15) = 'TMax'
	names(16) = 'TMin'
	names(17) = 'TD'
	names(18) = 'T-TD'
	names(33) = 'U'
	names(34) = 'V'
	names(35) = 'Psi'
	names(36) = 'Chi'
	names(39) = 'Omega'
	names(51) = 'SpecH'
	names(52) = 'RH'
	names(53) = 'MixRatio'
	names(54) = 'PrcpWatr'
	names(57) = 'Evap'
	names(61) = 'TtlPrcp'
	names(62) = 'PrcpLrge'
	names(63) = 'PrcpCnvc'
	names(65) = 'SnowEqu'
	names(66) = 'SnowDpth'

	names(71) = 'Cloud'
	names(72) = 'CloudCnv'
	names(73) = 'CloudLow'
	names(74) = 'CloudMid'
	names(75) = 'CloudHi'
	names(80) = 'TWater'
	names(81) = 'LSMask'
	names(84) = 'Albedo'
	names(85) = 'SoilTemp'
	names(86) = 'SoilMois'
	names(111) = 'SWRSfc'
	names(112) = 'LWRSfc'
	names(113) = 'SWRTop'
	names(114) = 'LWRTop'
	names(115) = 'LWR'
	names(116) = 'SWR'
	names(117) = 'GlblRad'
	names(121) = 'LHF'
	names(122) = 'SHF'
	names(150) = 'CovUV'
	names(151) = 'CovUT'
	names(152) = 'CovVT'
	names(155) = 'GFlux'
	names(170) = 'UStress'
	names(171) = 'VStress'
	names(175) = 'PSigLev'

        names(204) = 'SWRDn'
        names(205) = 'LWRDn'
        names(211) = 'SWRUp'
        names(212) = 'LWRUp'

	return
	end

	subroutine name2id(name,id)
c
c	given name (text), return grib-id
c	only common ones supported
c
	character names(255)*8, name*(*)
	common /shname/names

	call initnm
	do 10 i = 1, 255
	    if (names(i).eq.name) then
		id = i
		return
	    endif
10	continue
	write(*,*) 'fix initnm:',name
	stop
	end

	subroutine id2name(id,name)
c
c	given grib-id, return short name
c	only common ones supported
c
	character names(255)*8, name*(*)
	common /shname/names

	call initnm
	name = names(id)
	return
	end

	subroutine setname(kpds, kgds, name)
c
c	set the name of the variable
c	only common one supported
c
	integer kpds(*), kgds(*)
	character*(*) name

	call initnm
	call name2id(name,id)
	if (id.eq.-1) then
	    kpds(5) = 0
	    write(*,*) 'unknown name'
	else
	    kpds(5) = id
	endif
	return
	end

	subroutine setdate(kpds,kgds,iyr,imo,iday,ihour)
c
c	sets the date
c
	integer kpds(*), kgds(*)
	kpds(8) = iyr
	kpds(9) = imo
	kpds(10) = iday
	kpds(11) = ihour
	kpds(12) = 0
	kpds(13) = 0

	return
	end

	subroutine getdate(kpds,kgds,iyr,imo,iday,ihour)
c
c	gets the date
c
	integer kpds(*), kgds(*)
	iyr = kpds(8)
	imo = kpds(9)
	iday = kpds(10)
	ihour = kpds(11)

	return
	end


	subroutine getbit(kpds, kgds, hasbit)
c
c	check for a bitmap
c
	integer kpds(*), kgds(*)
	logical hasbit

	hasbit = mod(kpds(4)/64,2) .eq. 1

	return
	end

        subroutine setbit(kpds, kgds, hasbit)
c
c       set flag for a bitmap
c
        integer kpds(*), kgds(*)
        logical hasbit

	ilow = mod(kpds(4),64)
	ihigh = kpds(4)/128

	if (hasbit) then
	    kpds(4) = ihigh*128 + 64 + ilow
	else
	    kpds(4) = ihigh*128      + ilow
	endif

        return
        end

	subroutine setid(kpds, kgds, id)
c
c	sets id
c
	integer kpds(*), kgds(*)
	kpds(5) = id
	return
	end

	subroutine getid(kpds, kgds, id)
c
c	sets id
c
	integer kpds(*), kgds(*)
	id = kpds(5)
	return
	end

	subroutine gettr(kpds, kgds, trange)
c
c	trange = 'inst', 'acc','ave','climo'
c
	integer kpds(*), kgds(*), itr
	character*(*) trange

	itr = kpds(16)
	if (itr.eq.3) then
	    trange = 'ave'
	elseif (itr.eq.4) then
	    trange = 'acc'
	elseif (itr.eq.51) then
	    trange = 'climo'
	elseif (itr.eq.10) then
	    trange = 'inst'
	elseif (itr.eq.113) then
	    trange = 'ave-in'
	elseif (itr.eq.118) then
	    trange = 'var'
	elseif (itr.eq.123) then
	    trange = 'ave-un'
	else
	    write(*,*) '*** error in gettr (get time-range)'
	    write(*,*) 'kpds(16) =', itr
	    call exit(99)
	endif
	return
	end


	subroutine settr(kpds, kgds, trange)
c
c	trange = 'inst', 'acc','ave','climo'
c
	integer kpds(*), kgds(*), itr
	character*(*) trange

	if (trange.eq.'ave') then
	    kpds(16) = 3
	elseif (trange.eq.'acc') then
	    kpds(16) = 4
	else if (trange.eq.'climo') then
	    kpds(16) = 51
	else if (trange.eq.'inst') then
	    kpds(16) = 10
	else if (trange.eq.'ave-in') then
	    kpds(16) = 113
	else if (trange.eq.'var') then
	    kpds(16) = 118
	else if (trange.eq.'ave-un') then
	    kpds(16) = 123
	else
	    write(*,*) '*** error in settr (get time-range) ',trange
	    call exit(99)
	endif
	end

	integer function isrchne(n, x, inc, target)
c
c	search a x(..) for 1st element ne to target
c
	integer x(*), target
	integer n, inc

	isrchne = 0
	if (n.le.0) return
	j = 1
	do i = 1, n
	    if (x(j).ne.target) then
		isrchne = i
		return
	    endif
	    j = j + inc
	enddo
	isrchne = n + 1
	return
	end

c real version of isrchne
        integer function isrchner(n, x, inc, target)
c
c       search a x(..) for 1st element ne to target
c
        real x(*), target
        integer n, inc

        isrchner = 0
        if (n.le.0) return
        j = 1
        do i = 1, n
            if (x(j).ne.target) then
                isrchner = i
                return
            endif
            j = j + inc
        enddo
        isrchner = n + 1
        return
        end

c      kpds(5) mnomonics

       block data

       character*8 kpds5(0:255)
       common /cname5/kpds5

       data kpds5(0)/" "/
c      Pressure                            
       data kpds5(1)/"PRES"/
c      Pressure reduced to MSL             
       data kpds5(2)/"PRMSL"/
c      Pressure tendency                   
       data kpds5(3)/"PTEND"/
       data kpds5(4)/" "/
       data kpds5(5)/" "/
c      Geopotential                        
       data kpds5(6)/"GP"/
c      Geopotential height                 
       data kpds5(7)/"HGT"/
c      Geometric height                    
       data kpds5(8)/"DIST"/
c      Standard deviation of height        
       data kpds5(9)/"HSTDV"/
c      Variance of height                  
       data kpds5(10)/"HVAR"/
c      Temperature                         
       data kpds5(11)/"TMP"/
c      Virtual temperature                 
       data kpds5(12)/"VTMP"/
c      Potential temperature               
       data kpds5(13)/"POT"/
c      Pseudo-adiabatic potential temperatu
       data kpds5(14)/"EPOT"/
c      Maximum temperature                 
       data kpds5(15)/"TMAX"/
c      Minimum temperature                 
       data kpds5(16)/"TMIN"/
c      Dew point temperature               
       data kpds5(17)/"DPT"/
c      Dew point depression                
       data kpds5(18)/"DEPR"/
c      Lapse rate                          
       data kpds5(19)/"LAPR"/
c      Visibility                          
       data kpds5(20)/"VISIB"/
c      Radar spectra (1)                   
       data kpds5(21)/"RDSP1"/
c      Radar spectra (2)                   
       data kpds5(22)/"RDSP2"/
c      Radar spectra (3)                   
       data kpds5(23)/"RDSP3"/
       data kpds5(24)/" "/
c      Temperature anomaly                 
       data kpds5(25)/"TMPA"/
c      Pressure anomaly                    
       data kpds5(26)/"PRESA"/
c      Geopotential height anomaly         
       data kpds5(27)/"GPA"/
c      Wave spectra (1)                    
       data kpds5(28)/"WVSP1"/
c      Wave spectra (2)                    
       data kpds5(29)/"WVSP2"/
c      Wave spectra (3)                    
       data kpds5(30)/"WVSP3"/
c      Wind direction                      
       data kpds5(31)/"WDIR"/
c      Wind speed                          
       data kpds5(32)/"WIND"/
c      u wind                              
       data kpds5(33)/"UGRD"/
c      v wind                              
       data kpds5(34)/"VGRD"/
c      Stream function                     
       data kpds5(35)/"STRM"/
c      Velocity potential                  
       data kpds5(36)/"VPOT"/
c      Montgomery stream function          
       data kpds5(37)/"MNTSF"/
c      Sigma coord. vertical velocity      
       data kpds5(38)/"SGCVV"/
c      Pressure vertical velocity          
       data kpds5(39)/"VVEL"/
c      Geometric vertical velocity         
       data kpds5(40)/"DZDT"/
c      Absolute vorticity                  
       data kpds5(41)/"ABSV"/
c      Absolute divergence                 
       data kpds5(42)/"ABSD"/
c      Relative vorticity                  
       data kpds5(43)/"RELV"/
c      Relative divergence                 
       data kpds5(44)/"RELD"/
c      Vertical u shear                    
       data kpds5(45)/"VUCSH"/
c      Vertical v shear                    
       data kpds5(46)/"VVCSH"/
c      Direction of current                
       data kpds5(47)/"DIRC"/
c      Speed of current                    
       data kpds5(48)/"SPC"/
c      u of current                        
       data kpds5(49)/"UOGRD"/
c      v of current                        
       data kpds5(50)/"VOGRD"/
c      Specific humidity                   
       data kpds5(51)/"SPFH"/
c      Relative humidity                   
       data kpds5(52)/"RH"/
c      Humidity mixing ratio               
       data kpds5(53)/"MIXR"/
c      Precipitable water                  
       data kpds5(54)/"PWAT"/
c      Vapor pressure                      
       data kpds5(55)/"VAPP"/
c      Saturation deficit                  
       data kpds5(56)/"SATD"/
c      Evaporation                         
       data kpds5(57)/"EVP"/
c      Cloud Ice                           
       data kpds5(58)/"CICE"/
c      Precipitation rate                  
       data kpds5(59)/"PRATE"/
c      Thunderstorm probability            
       data kpds5(60)/"TSTM"/
c      Total precipitation                 
       data kpds5(61)/"APCP"/
c      Large scale precipitation           
       data kpds5(62)/"NCPCP"/
c      Convective precipitation            
       data kpds5(63)/"ACPCP"/
c      Snowfall rate water equivalent      
       data kpds5(64)/"SRWEQ"/
c      Water equiv. of accum. snow depth   
       data kpds5(65)/"WEASD"/
c      Snow depth                          
       data kpds5(66)/"SNOD"/
c      Mixed layer depth                   
       data kpds5(67)/"MIXHT"/
c      Transient thermocline depth         
       data kpds5(68)/"TTHDP"/
c      Main thermocline depth              
       data kpds5(69)/"MTHD"/
c      Main thermocline anomaly            
       data kpds5(70)/"MTHA"/
c      Total cloud cover                   
       data kpds5(71)/"TCDC"/
c      Convective cloud cover              
       data kpds5(72)/"CDCON"/
c      Low level cloud cover               
       data kpds5(73)/"LCDC"/
c      Mid level cloud cover               
       data kpds5(74)/"MCDC"/
c      High level cloud cover              
       data kpds5(75)/"HCDC"/
c      Cloud water                         
       data kpds5(76)/"CWAT"/
       data kpds5(77)/" "/
c      Convective snow                     
       data kpds5(78)/"SNOC"/
c      Large scale snow                    
       data kpds5(79)/"SNOL"/
c      Water temperature                   
       data kpds5(80)/"WTMP"/
c      Land-sea mask (1=land; 0=sea)       
       data kpds5(81)/"LAND"/
c      Deviation of sea level from mean    
       data kpds5(82)/"DSLM"/
c      Surface roughness                   
       data kpds5(83)/"SFCR"/
c      Albedo                              
       data kpds5(84)/"ALBDO"/
c      Soil temperature                    
       data kpds5(85)/"TSOIL"/
c      Soil moisture content               
       data kpds5(86)/"SOILM"/
c      Vegetation                          
       data kpds5(87)/"VEG"/
c      Salinity                            
       data kpds5(88)/"SALTY"/
c      Density                             
       data kpds5(89)/"DEN"/
c      Runoff                              
       data kpds5(90)/"RUNOF"/
c      Ice concentration (ice=1; no ice=0) 
       data kpds5(91)/"ICEC"/
c      Ice thickness                       
       data kpds5(92)/"ICETK"/
c      Direction of ice drift              
       data kpds5(93)/"DICED"/
c      Speed of ice drift                  
       data kpds5(94)/"SICED"/
c      u of ice drift                      
       data kpds5(95)/"UICE"/
c      v of ice drift                      
       data kpds5(96)/"VICE"/
c      Ice growth                          
       data kpds5(97)/"ICEG"/
c      Ice divergence                      
       data kpds5(98)/"ICED"/
c      Snow melt                           
       data kpds5(99)/"SNOM"/
c      Sig height of wind waves and swell  
       data kpds5(100)/"HTSGW"/
c      Direction of wind waves             
       data kpds5(101)/"WVDIR"/
c      Significant height of wind waves    
       data kpds5(102)/"WVHGT"/
c      Mean period of wind waves           
       data kpds5(103)/"WVPER"/
c      Direction of swell waves            
       data kpds5(104)/"SWDIR"/
c      Significant height of swell waves   
       data kpds5(105)/"SWELL"/
c      Mean period of swell waves          
       data kpds5(106)/"SWPER"/
c      Primary wave direction              
       data kpds5(107)/"DIRPW"/
c      Primary wave mean period            
       data kpds5(108)/"PERPW"/
c      Secondary wave direction            
       data kpds5(109)/"DIRSW"/
c      Secondary wave mean period          
       data kpds5(110)/"PERSW"/
c      Net short wave radiation (surface)  
       data kpds5(111)/"NSWRS"/
c      Net long wave radiation (surface)   
       data kpds5(112)/"NLWRS"/
c      Net short wave radiation (top)      
       data kpds5(113)/"NSWRT"/
c      Net long wave radiation (top)       
       data kpds5(114)/"NLWRT"/
c      Long wave radiation                 
       data kpds5(115)/"LWAVR"/
c      Short wave radiation                
       data kpds5(116)/"SWAVR"/
c      Global radiation                    
       data kpds5(117)/"GRAD"/
       data kpds5(118)/" "/
       data kpds5(119)/" "/
       data kpds5(120)/" "/
c      Latent heat flux                    
       data kpds5(121)/"LHTFL"/
c      Sensible heat flux                  
       data kpds5(122)/"SHTFL"/
c      Boundary layer dissipation          
       data kpds5(123)/"BLYDP"/
c      Zonal component of momentum flux    
       data kpds5(124)/"UFLX"/
c      Meridional component of momentum flu
       data kpds5(125)/"VFLX"/
c      Wind mixing energy                  
       data kpds5(126)/"WMIXE"/
c      Image data                          
       data kpds5(127)/"IMGD"/
c      Mean sea level pressure (Std Atm)   
       data kpds5(128)/"MSLSA"/
c      Mean sea level pressure (MAPS)      
       data kpds5(129)/"MSLMA"/
c      Mean sea level pressure (ETA model) 
       data kpds5(130)/"MSLET"/
c      Surface lifted index                
       data kpds5(131)/"LFTX"/
c      Best (4-layer) lifted index         
       data kpds5(132)/"4LFTX"/
c      K index                             
       data kpds5(133)/"KX"/
c      Sweat index                         
       data kpds5(134)/"SX"/
c      Horizontal moisture divergence      
       data kpds5(135)/"MCONV"/
c      Vertical speed shear                
       data kpds5(136)/"VSSH"/
c      3-hr pressure tendency              
       data kpds5(137)/"TSLSA"/
c      Brunt-Vaisala frequency squared     
       data kpds5(138)/"BVF2"/
c      Potential vorticity (mass-weighted) 
       data kpds5(139)/"PVMW"/
c      Categorical rain (yes=1;no=0)       
       data kpds5(140)/"CRAIN"/
c      Categorical freezing rain (yes=1;no=
       data kpds5(141)/"CFRZR"/
c      Categorical ice pellets (yes=1;no=0)
       data kpds5(142)/"CICEP"/
c      Categorical snow (yes=1;no=0)       
       data kpds5(143)/"CSNOW"/
c      Volumetric soil moisture content    
       data kpds5(144)/"SOILW"/
c      Potential evaporation rate          
       data kpds5(145)/"PEVPR"/
c      Cloud work function                 
       data kpds5(146)/"CWORK"/
c      Zonal gravity wave stress           
       data kpds5(147)/"U-GWD"/
c      Meridional gravity wave stress      
       data kpds5(148)/"V-GWD"/
c      Potential vorticity                 
       data kpds5(149)/"PV___"/
       data kpds5(150)/" "/
       data kpds5(151)/" "/
       data kpds5(152)/" "/
c      Moisture flux divergence            
       data kpds5(153)/"MFXDV"/
       data kpds5(154)/" "/
c      Ground heat flux                    
       data kpds5(155)/"GFLUX"/
c      Convective inhibition               
       data kpds5(156)/"CIN"/
c      Convective Available Potential Energ
       data kpds5(157)/"CAPE"/
c      Turbulent kinetic energy            
       data kpds5(158)/"TKE"/
c      Condensation pressure of lifted parc
       data kpds5(159)/"CONDP"/
c      Clear sky upward solar flux         
       data kpds5(160)/"CSUSF"/
c      Clear sky downward solar flux       
       data kpds5(161)/"CSDSF"/
c      Clear sky upward long wave flux     
       data kpds5(162)/"CSULF"/
c      Clear sky downward long wave flux   
       data kpds5(163)/"CSDLF"/
c      Cloud forcing net solar flux        
       data kpds5(164)/"CFNSF"/
c      Cloud forcing net long wave flux    
       data kpds5(165)/"CFNLF"/
c      Visible beam downward solar flux    
       data kpds5(166)/"VBDSF"/
c      Visible diffuse downward solar flux 
       data kpds5(167)/"VDDSF"/
c      Near IR beam downward solar flux    
       data kpds5(168)/"NBDSF"/
c      Near IR diffuse downward solar flux 
       data kpds5(169)/"NDDSF"/
c      U wind stress                       
       data kpds5(170)/"USTR"/
c      V wind stress                       
       data kpds5(171)/"VSTR"/
c      Momentum flux                       
       data kpds5(172)/"MFLX"/
c      Mass point model surface            
       data kpds5(173)/"LMH"/
c      Velocity point model surface        
       data kpds5(174)/"LMV"/
c      Nearby model level                  
       data kpds5(175)/"SGLYR"/
c      Latitude                            
       data kpds5(176)/"NLAT"/
c      Longitude                           
       data kpds5(177)/"NLON"/
c      Mass weighted u                     
       data kpds5(178)/"UMAS"/
c      Mass weighted v                     
       data kpds5(179)/"VMAS"/
       data kpds5(180)/" "/
c      x-gradient of log pressure          
       data kpds5(181)/"LPSX"/
c      y-gradient of log pressure          
       data kpds5(182)/"LPSY"/
c      x-gradient of height                
       data kpds5(183)/"HGTX"/
c      y-gradient of height                
       data kpds5(184)/"HGTY"/
c      Standard deviation of Geop. hgt.    
       data kpds5(185)/"STDZ"/
c      Standard deviation of zonal wind    
       data kpds5(186)/"STDU"/
c      Standard deviation of meridional win
       data kpds5(187)/"STDV"/
c      Standard deviation of spec. hum.    
       data kpds5(188)/"STDQ"/
c      Standard deviation of temperature   
       data kpds5(189)/"STDT"/
c      Covariance between u and omega      
       data kpds5(190)/"CBUW"/
c      Covariance between v and omega      
       data kpds5(191)/"CBVW"/
c      Covariance between u and specific hu
       data kpds5(192)/"CBUQ"/
c      Covariance between v and specific hu
       data kpds5(193)/"CBVQ"/
c      Covariance between T and omega      
       data kpds5(194)/"CBTW"/
c      Covariance between spec. hum and ome
       data kpds5(195)/"CBQW"/
c      Covariance between v and u          
       data kpds5(196)/"CBMZW"/
c      Covariance between u and T          
       data kpds5(197)/"CBTZW"/
c      Covariance between v and T          
       data kpds5(198)/"CBTMW"/
c      Standard deviation of Rel. Hum.     
       data kpds5(199)/"STDRH"/
c      Std dev of time tend of geop. hgt   
       data kpds5(200)/"SDTZ"/
c      Ice-free water surface              
       data kpds5(201)/"ICWAT"/
c      Std dev of time tend of zonal wind  
       data kpds5(202)/"SDTU"/
c      Std dev of time tend of merid wind  
       data kpds5(203)/"SDTV"/
c      Downward solar radiation flux       
       data kpds5(204)/"DSWRF"/
c      Downward long wave radiation flux   
       data kpds5(205)/"DLWRF"/
c      Std dev of time tend of spec. hum   
       data kpds5(206)/"SDTQ"/
c      Moisture availability               
       data kpds5(207)/"MSTAV"/
c      Exchange coefficient                
       data kpds5(208)/"SFEXC"/
c      Number of mixed layers next to sfc  
       data kpds5(209)/"MIXLY"/
c      Std dev of time tend of temperature 
       data kpds5(210)/"SDTT"/
c      Upward solar radiation flux         
       data kpds5(211)/"USWRF"/
c      Upward long wave radiation flux     
       data kpds5(212)/"ULWRF"/
c      Amount of non-convective cloud      
       data kpds5(213)/"CDLYR"/
c      Convective precipitation rate       
       data kpds5(214)/"CPRAT"/
c      Temperature tendency by all physics 
       data kpds5(215)/"TTDIA"/
c      Temperature tendency by all radiatio
       data kpds5(216)/"TTRAD"/
c      Temperature tendency by nonrad physi
       data kpds5(217)/"TTPHY"/
c      Precipitation index                 
       data kpds5(218)/"PREIX"/
c      Std dev of IR T over 1x1 deg area   
       data kpds5(219)/"TSD1D"/
c      Natural log of surface pressure     
       data kpds5(220)/"NLSGP"/
c      Std dev of time tend of rel hum     
       data kpds5(221)/"SDTRH"/
c      5-wave geopotential height          
       data kpds5(222)/"5WAVH"/
c      Plant canopy surface water          
       data kpds5(223)/"CWAT"/
c      Maximum stomato plant resistance    
       data kpds5(224)/"PLTRS"/
c      RH-type cloud cover                 
       data kpds5(225)/"RHCLD"/
c      Blackadar's mixing length scale     
       data kpds5(226)/"BMIXL"/
c      Asymptotic mixing length scale      
       data kpds5(227)/"AMIXL"/
c      Potential evaporation               
       data kpds5(228)/"PEVAP"/
c      Snow melt heat flux                 
       data kpds5(229)/"SNOHF"/
c      Snow sublimation heat fulx          
       data kpds5(230)/"SNOEV"/
c      Convective cloud mass flux          
       data kpds5(231)/"MFLUX"/
c      Downward total radiation flux       
       data kpds5(232)/"DTRF"/
c      Upward total radiation flux         
       data kpds5(233)/"UTRF"/
c      Baseflow-groundwater runoff         
       data kpds5(234)/"BGRUN"/
c      Storm surface runoff                
       data kpds5(235)/"SSRUN"/
       data kpds5(236)/" "/
c      Total column ozone concentration    
       data kpds5(237)/"OZONE"/
c      Snow cover                          
       data kpds5(238)/"SNOC"/
c      Snow temperature                    
       data kpds5(239)/"SNOT"/
c      Permanent snow points               
       data kpds5(240)/"GLCR"/
c      Large scale condensation heating rat
       data kpds5(241)/"LRGHR"/
c      Deep convective heating rate        
       data kpds5(242)/"CNVHR"/
c      Deep convective moistening rate     
       data kpds5(243)/"CNVMR"/
c      Shallow convective heating rate     
       data kpds5(244)/"SHAHR"/
c      Shallow convective moistening rate  
       data kpds5(245)/"SHAMR"/
c      Vertical diffusion heating rate     
       data kpds5(246)/"VDFHR"/
c      Vertical diffusion zonal accel      
       data kpds5(247)/"VDFUA"/
c      Vertical diffusion meridional accel 
       data kpds5(248)/"VDFVA"/
c      Vertical diffusion moistening rate  
       data kpds5(249)/"VDFMR"/
c      Solar radiative heating rate        
       data kpds5(250)/"SWHR"/
c      Longwave radiative heating rate     
       data kpds5(251)/"LWHR"/
c      Drag coefficient                    
       data kpds5(252)/"CD"/
c      Friction velocity                   
       data kpds5(253)/"FRICV"/
c      Richardson number                   
       data kpds5(254)/"RI"/
       data kpds5(255)/" "/
       end
c

       subroutine k5toa(i,name)

       character*8 kpds5(0:255)
       character*(*) name
       common /cname5/kpds5
       name = kpds5(i)
       return
       end

       subroutine atok5(name,i)

       character*8 kpds5(0:255)
       character*(*) name
       integer atoi
       common /cname5/kpds5

       i = atoi(name)
       if (i.gt.9) return

       do 10 i = 0, 255
          if (name.eq.kpds5(i)) return
10     continue
       i = -1
       return
       end


        integer function atoi(st)
c
c       Fortran version of C function atoi()
c
        character*(*) st
        integer i,n,sign,lenst

        sign = 1
        n = 0
        lenst = len(st)

c       skip leading blanks

        i = 1
10      if (i.gt.lenst) goto 20
            if (st(i:i).ne.' ') goto 20
            i = i + 1
            goto 10

20      if (i.gt.lenst) then
            atoi = 0
            return
        endif

c       check for +/-
        if (st(i:i).eq.'-') then
            sign = -1
            i = i + 1
        else if (st(i:i).eq.'+') then
            sign = 1
            i = i + 1
        endif

c       *** digits ***

200     if (i.gt.lenst) goto 300
            if (st(i:i) .lt.'0' .or. st(i:i).gt.'9') goto 300
            n = n*10 + mova2i(st(i:i)) - mova2i('0')
            i = i + 1
            goto 200

300     continue
        atoi = sign * n
        return
        end

	subroutine exit(n)
c
c	want to set a return code on ibm/sp
c
	if (n.eq.0) stop 0
	if (n.eq.1) stop 1
	if (n.eq.2) stop 2
	if (n.eq.3) stop 3
	if (n.eq.4) stop 4
	if (n.eq.5) stop 5
	if (n.eq.6) stop 6
	if (n.eq.7) stop 7
	if (n.eq.8) stop 8
	if (n.eq.9) stop 9
	stop 10
	end

c
c	from ~wd20mi/jifnov93/rdg.f
c  grib routine for version1 type index files
c
c change:
c	added new routines PDS56B, PDSCAB, PDSCAC
c	identical to PDS567, PDSCAB except a name change
c	this prevents the buffer from being flushed
c
c
      SUBROUTINE RDGB(LUGB,LGRIB,LSKIP,KPDS,KGDS,NDATA,LBMS,DATA)
C
C  READ GRIB FILE
C  INPUT
C    LUGB - LOGICAL UNIT TO READ
C    LGRIB - LENGTH OF GRIB RECORD
C    LSKIP - BYTES TO SKIP FOR GRIB RECORD
C  OUTPUT
C    KPDS(100) - UNPACKED PRODUCT DEFINITION SECTION
C    KGDS(100) - UNPACKED GRID DEFINITION SECTION
C    NDATA    - NUMBER OF DATA POINTS
C    LBMS(NDATA) - LOGICAL BIT MAP
C    DATA(NDATA) - DATA UNPACKED
C
      CHARACTER GRIB(LGRIB)*1
      INTEGER KPDS(100),KGDS(100),KPTR(16)
      LOGICAL LBMS(*)
      REAL DATA(*)
      NDATA=0
      CALL BAREAD(LUGB,LSKIP,LGRIB,LREAD,GRIB)
      IF(LREAD.LT.LGRIB) RETURN
      CALL W3FI63(GRIB,KPDS,KGDS,LBMS,DATA,KPTR,IRET)
c     IF(IRET.NE.0) RETURN
      IF(IRET.NE.0) then
          write(*,*) 'error decoding file: rdgb'
          call exit(8)
      endif
      NDATA=KPTR(10)
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE PDS567(LUGI,KPDS5,KPDS6,KPDS7,INUM,LSKIP,LGRIB)
C
C  SEARCH GRIB1 INDEX FILE FOR GIVEN PARAMETER AND LEVEL.
C
C  LUGI     - INPUT INTEGER UNIT OF GRIB1 INDEX FILE (GB1IX1) TO READ
C  KPDS5    - INPUT INTEGER PARAMETER NUMBER TO FIND (-1 FOR WILDCARD)
C  KPDS6    - INPUT INTEGER LEVEL TYPE TO FIND (-1 FOR WILDCARD)
C  KPDS7    - INPUT INTEGER LEVEL VALUE TO FIND (-1 FOR WILDCARD)
C  INUM     - INPUT AND OUTPUT INTEGER RECORD NUMBER
C  LSKIP    - OUTPUT INTEGER BYTES TO SKIP IN GRIB1 DATA FILE
C  LGRIB    - OUTPUT INTEGER BYTES TO READ IN GRIB1 DATA FILE
C             (0 IF RECORD NOT FOUND)
C
c      PARAMETER(MBUF=8192*128)
      PARAMETER(MBUF=2300000)
      CHARACTER CBUF(MBUF)
      SAVE LUX,NSKP,NLEN,NNUM,CBUF
      DATA LUX/0/
      CHARACTER CHEAD(2)*81
c	wne
      IF(LUGI.NE.LUX.or.INUM.LT.0) THEN
c       REWIND LUGI
c       READ(LUGI,IOSTAT=IOS) CHEAD
        call baread(lugi,0,162,ka,chead)
        ios=0
        if (ka.ne.162) ios=1

        IF(IOS.EQ.0.AND.CHEAD(1)(42:47).EQ.'GB1IX1') THEN
          LUX=0
          READ(CHEAD(2),'(8X,3I10,2X,A40)',IOSTAT=IOS) NSKP,NLEN,NNUM
          IF(IOS.EQ.0) THEN
            NBUF=NNUM*NLEN
            IF(NBUF.GT.MBUF) THEN
              PRINT *,'PDS567: INCREASE BUFFER FROM ',MBUF,' TO ',NBUF
              NNUM=MBUF/NLEN
              NBUF=NNUM*NLEN
            ENDIF
            CALL BAREAD(LUGI,NSKP,NBUF,LBUF,CBUF)
            IF(LBUF.EQ.NBUF) THEN
              LUX=LUGI
              INUM=0
            ENDIF
          ENDIF
        ENDIF
      ENDIF
      LGRIB=0
      IF(LUGI.EQ.LUX) THEN
        N=INUM+1
        DOWHILE(LGRIB.EQ.0.AND.N.LE.NNUM)
          IF((KPDS5.EQ.-1.OR.KPDS5.EQ.mova2i(CBUF((N-1)*NLEN+34))).AND.
     &       (KPDS6.EQ.-1.OR.KPDS6.EQ.mova2i(CBUF((N-1)*NLEN+35))).AND.
     &       (KPDS7.EQ.-1.OR.KPDS7.EQ.mova2i(CBUF((N-1)*NLEN+36))*256+
     &                                mova2i(CBUF((N-1)*NLEN+37)))) THEN
            INUM=N
            CALL GBYTEc(CBUF,LSKIP,8*(N-1)*NLEN,8*4)
            CALL GBYTEc(CBUF,LGRIB,8*(N-1)*NLEN+8*20,8*4)
          ENDIF
          N=N+1
        ENDDO
      ENDIF
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE PDSCAN(LUGI,KPDS,INUM,LSKIP,LGRIB)
C
C  SEARCH GRIB1 INDEX FILE FOR GIVEN PDS PARAMETERS.
C
C  LUGI     - INPUT INTEGER UNIT OF GRIB1 INDEX FILE (GB1IX1) TO READ
C  KPDS     - INPUT AND OUTPUT INTEGER (100) PDS LIST TO MATCH
C             (SAME DEFINITIONS AS IN W3FI63) (-1 FOR WILDCARD)
C  INUM     - INPUT AND OUTPUT INTEGER RECORD NUMBER (-1 TO REOPEN FILE)
C  LSKIP    - OUTPUT INTEGER BYTES TO SKIP IN GRIB1 DATA FILE
C  LGRIB    - OUTPUT INTEGER BYTES TO READ IN GRIB1 DATA FILE
C             (0 IF RECORD NOT FOUND)
C
      INTEGER KPDS(100)
c      PARAMETER(MBUF=8192*128)
      PARAMETER(MBUF=2300000)
      CHARACTER CBUF(MBUF)
      SAVE LUX,NSKP,NLEN,NNUM,CBUF
      DATA LUX/0/
      CHARACTER CHEAD(2)*81
      CHARACTER CPDS(28)
      INTEGER KPTR(16),KPDSI(100)
      LOGICAL LMATCH
c	write(*,*) '>>pdscan'
      IF(INUM.LT.0.OR.LUGI.NE.LUX) THEN
c       REWIND LUGI
c       READ(LUGI,IOSTAT=IOS) CHEAD
        call baread(lugi,0,162,ka,chead)
        ios=0
        if (ka.ne.162) ios=1

        IF(IOS.EQ.0.AND.CHEAD(1)(42:47).EQ.'GB1IX1') THEN
          LUX=0
          READ(CHEAD(2),'(8X,3I10,2X,A40)',IOSTAT=IOS) NSKP,NLEN,NNUM
          IF(IOS.EQ.0) THEN
            NBUF=NNUM*NLEN
            IF(NBUF.GT.MBUF) THEN
              PRINT *,'PDS567: INCREASE BUFFER FROM ',MBUF,' TO ',NBUF
              NNUM=MBUF/NLEN
              NBUF=NNUM*NLEN
            ENDIF
            CALL BAREAD(LUGI,NSKP,NBUF,LBUF,CBUF)
            IF(LBUF.EQ.NBUF) THEN
              LUX=LUGI
              INUM=0
            ENDIF
          ENDIF
        ENDIF
      ENDIF
      LGRIB=0
      IF(INUM.GE.0.AND.LUGI.EQ.LUX) THEN
        N=INUM+1
        DOWHILE(LGRIB.EQ.0.AND.N.LE.NNUM)
c         CPDS=CBUF((N-1)*NLEN+26:(N-1)*NLEN+53)
	  do i9 = 1, 28
	     cpds(i9) = CBUF((N-1)*NLEN+25+i9)
	  enddo
          call ifill(KPTR,16,0)
          CALL GBYTEc(CBUF,KPTR(3),(N-1)*NLEN*8+25*8,3*8)
          CALL FI632(CPDS,KPTR,KPDSI,IRET)
          LMATCH=.TRUE.
          IP=1
          DOWHILE(LMATCH.AND.IP.LE.100)
            LMATCH=KPDS(IP).EQ.-1.OR.KPDS(IP).EQ.KPDSI(IP)
            IP=IP+1
          ENDDO
          IF(LMATCH) THEN
c           KPDS=KPDSI
	    call ifillv(kpds,kpdsi,100)
            INUM=N
            CALL GBYTEc(CBUF,LSKIP,(N-1)*NLEN*8,4*8)
            CALL GBYTEc(CBUF,LGRIB,(N-1)*NLEN*8+20*8,4*8)
          ENDIF
          N=N+1
        ENDDO
      ENDIF
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE PDS56B(LUGI,KPDS5,KPDS6,KPDS7,INUM,LSKIP,LGRIB)
c
c identical to PDS567 except for the name
c so that you can keep 2 files open at the same time with
c out having to flush out the buffers
C
C  SEARCH GRIB1 INDEX FILE FOR GIVEN PARAMETER AND LEVEL.
C
C  LUGI     - INPUT INTEGER UNIT OF GRIB1 INDEX FILE (GB1IX1) TO READ
C  KPDS5    - INPUT INTEGER PARAMETER NUMBER TO FIND (-1 FOR WILDCARD)
C  KPDS6    - INPUT INTEGER LEVEL TYPE TO FIND (-1 FOR WILDCARD)
C  KPDS7    - INPUT INTEGER LEVEL VALUE TO FIND (-1 FOR WILDCARD)
C  INUM     - INPUT AND OUTPUT INTEGER RECORD NUMBER
C  LSKIP    - OUTPUT INTEGER BYTES TO SKIP IN GRIB1 DATA FILE
C  LGRIB    - OUTPUT INTEGER BYTES TO READ IN GRIB1 DATA FILE
C             (0 IF RECORD NOT FOUND)
C
c     PARAMETER(MBUF=8192*128)
      PARAMETER(MBUF=2300000)
      CHARACTER CBUF(MBUF)
      SAVE LUX,NSKP,NLEN,NNUM,CBUF
      DATA LUX/0/
      CHARACTER CHEAD(2)*81
c	wne
      IF(LUGI.NE.LUX.or.INUM.LT.0) THEN
c       REWIND LUGI
c       READ(LUGI,IOSTAT=IOS) CHEAD
        call baread(lugi,0,162,ka,chead)
        ios=0
        if (ka.ne.162) ios=1

        IF(IOS.EQ.0.AND.CHEAD(1)(42:47).EQ.'GB1IX1') THEN
          LUX=0
          READ(CHEAD(2),'(8X,3I10,2X,A40)',IOSTAT=IOS) NSKP,NLEN,NNUM
          IF(IOS.EQ.0) THEN
            NBUF=NNUM*NLEN
            IF(NBUF.GT.MBUF) THEN
              PRINT *,'PDS567: INCREASE BUFFER FROM ',MBUF,' TO ',NBUF
              NNUM=MBUF/NLEN
              NBUF=NNUM*NLEN
            ENDIF
            CALL BAREAD(LUGI,NSKP,NBUF,LBUF,CBUF)
            IF(LBUF.EQ.NBUF) THEN
              LUX=LUGI
              INUM=0
            ENDIF
          ENDIF
        ENDIF
      ENDIF
      LGRIB=0
      IF(LUGI.EQ.LUX) THEN
        N=INUM+1
        DOWHILE(LGRIB.EQ.0.AND.N.LE.NNUM)
          IF((KPDS5.EQ.-1.OR.KPDS5.EQ.mova2i(CBUF((N-1)*NLEN+34))).AND.
     &       (KPDS6.EQ.-1.OR.KPDS6.EQ.mova2i(CBUF((N-1)*NLEN+35))).AND.
     &       (KPDS7.EQ.-1.OR.KPDS7.EQ.mova2i(CBUF((N-1)*NLEN+36))*256+
     &                                mova2i(CBUF((N-1)*NLEN+37)))) THEN
            INUM=N
            CALL GBYTEc(CBUF,LSKIP,8*(N-1)*NLEN,8*4)
            CALL GBYTEc(CBUF,LGRIB,8*(N-1)*NLEN+8*20,8*4)
          ENDIF
          N=N+1
        ENDDO
      ENDIF
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE PDSCAB(LUGI,KPDS,INUM,LSKIP,LGRIB)
C
C  SEARCH GRIB1 INDEX FILE FOR GIVEN PDS PARAMETERS.
C
C  LUGI     - INPUT INTEGER UNIT OF GRIB1 INDEX FILE (GB1IX1) TO READ
C  KPDS     - INPUT AND OUTPUT INTEGER (100) PDS LIST TO MATCH
C             (SAME DEFINITIONS AS IN W3FI63) (-1 FOR WILDCARD)
C  INUM     - INPUT AND OUTPUT INTEGER RECORD NUMBER (-1 TO REOPEN FILE)
C  LSKIP    - OUTPUT INTEGER BYTES TO SKIP IN GRIB1 DATA FILE
C  LGRIB    - OUTPUT INTEGER BYTES TO READ IN GRIB1 DATA FILE
C             (0 IF RECORD NOT FOUND)
C
      INTEGER KPDS(100)
c     PARAMETER(MBUF=8192*128)
      PARAMETER(MBUF=2300000)
      CHARACTER CBUF(MBUF)
      SAVE LUX,NSKP,NLEN,NNUM,CBUF
      DATA LUX/0/
      CHARACTER CHEAD(2)*81
      CHARACTER CPDS(28)
      INTEGER KPTR(16),KPDSI(100)
      LOGICAL LMATCH
      IF(INUM.LT.0.OR.LUGI.NE.LUX) THEN
c       REWIND LUGI
c       READ(LUGI,IOSTAT=IOS) CHEAD
        call baread(lugi,0,162,ka,chead)
        ios=0
        if (ka.ne.162) ios=1

        IF(IOS.EQ.0.AND.CHEAD(1)(42:47).EQ.'GB1IX1') THEN
          LUX=0
          READ(CHEAD(2),'(8X,3I10,2X,A40)',IOSTAT=IOS) NSKP,NLEN,NNUM
          IF(IOS.EQ.0) THEN
            NBUF=NNUM*NLEN
            IF(NBUF.GT.MBUF) THEN
              PRINT *,'PDS567: INCREASE BUFFER FROM ',MBUF,' TO ',NBUF
              NNUM=MBUF/NLEN
              NBUF=NNUM*NLEN
            ENDIF
            CALL BAREAD(LUGI,NSKP,NBUF,LBUF,CBUF)
            IF(LBUF.EQ.NBUF) THEN
              LUX=LUGI
              INUM=0
            ENDIF
          ENDIF
        ENDIF
      ENDIF
      LGRIB=0
      IF(INUM.GE.0.AND.LUGI.EQ.LUX) THEN
        N=INUM+1
        DOWHILE(LGRIB.EQ.0.AND.N.LE.NNUM)
c         CPDS=CBUF((N-1)*NLEN+26:(N-1)*NLEN+53)
	  do i9 = 1, 28
	     cpds(i9) = CBUF((N-1)*NLEN+25+i9)
	  enddo
c         KPTR=0
	  call ifill(kptr,16,0)
          CALL GBYTEc(CBUF,KPTR(3),(N-1)*NLEN*8+25*8,3*8)
          CALL FI632(CPDS,KPTR,KPDSI,IRET)
          LMATCH=.TRUE.
          IP=1
          DOWHILE(LMATCH.AND.IP.LE.22)
            LMATCH=KPDS(IP).EQ.-1.OR.KPDS(IP).EQ.KPDSI(IP)
            IP=IP+1
          ENDDO
          IF(LMATCH) THEN
c           KPDS=KPDSI
	    call ifillv(kpds,kpdsi,100)
            INUM=N
            CALL GBYTEc(CBUF,LSKIP,(N-1)*NLEN*8,4*8)
            CALL GBYTEc(CBUF,LGRIB,(N-1)*NLEN*8+20*8,4*8)
          ENDIF
          N=N+1
        ENDDO
      ENDIF
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE PDSCAC(LUGI,KPDS,INUM,LSKIP,LGRIB)
C
C  SEARCH GRIB1 INDEX FILE FOR GIVEN PDS PARAMETERS.
C
C  LUGI     - INPUT INTEGER UNIT OF GRIB1 INDEX FILE (GB1IX1) TO READ
C  KPDS     - INPUT AND OUTPUT INTEGER (100) PDS LIST TO MATCH
C             (SAME DEFINITIONS AS IN W3FI63) (-1 FOR WILDCARD)
C  INUM     - INPUT AND OUTPUT INTEGER RECORD NUMBER (-1 TO REOPEN FILE)
C  LSKIP    - OUTPUT INTEGER BYTES TO SKIP IN GRIB1 DATA FILE
C  LGRIB    - OUTPUT INTEGER BYTES TO READ IN GRIB1 DATA FILE
C             (0 IF RECORD NOT FOUND)
C
      INTEGER KPDS(100)
c     PARAMETER(MBUF=8192*128)
      PARAMETER(MBUF=2300000)
      CHARACTER CBUF(MBUF)
      SAVE LUX,NSKP,NLEN,NNUM,CBUF
      DATA LUX/0/
      CHARACTER CHEAD(2)*81
      CHARACTER CPDS(28)
      INTEGER KPTR(16),KPDSI(100)
      LOGICAL LMATCH
      IF(INUM.LT.0.OR.LUGI.NE.LUX) THEN
c       REWIND LUGI
c       READ(LUGI,IOSTAT=IOS) CHEAD
        call baread(lugi,0,162,ka,chead)
        ios=0
        if (ka.ne.162) ios=1
        
        IF(IOS.EQ.0.AND.CHEAD(1)(42:47).EQ.'GB1IX1') THEN
          LUX=0
          READ(CHEAD(2),'(8X,3I10,2X,A40)',IOSTAT=IOS) NSKP,NLEN,NNUM
          IF(IOS.EQ.0) THEN
            NBUF=NNUM*NLEN
            IF(NBUF.GT.MBUF) THEN
              PRINT *,'PDS567: INCREASE BUFFER FROM ',MBUF,' TO ',NBUF
              NNUM=MBUF/NLEN
              NBUF=NNUM*NLEN
            ENDIF
            CALL BAREAD(LUGI,NSKP,NBUF,LBUF,CBUF)
            IF(LBUF.EQ.NBUF) THEN
              LUX=LUGI
              INUM=0
            ENDIF
          ENDIF
        ENDIF
      ENDIF
      LGRIB=0
      IF(INUM.GE.0.AND.LUGI.EQ.LUX) THEN
        N=INUM+1
        DOWHILE(LGRIB.EQ.0.AND.N.LE.NNUM)
c         CPDS=CBUF((N-1)*NLEN+26:(N-1)*NLEN+53)
	  do i9 = 1, 28
	     cpds(i9) = CBUF((N-1)*NLEN+25+i9)
	  enddo
c         KPTR=0
          call ifill(kptr,16,0) 
          CALL GBYTEc(CBUF,KPTR(3),(N-1)*NLEN*8+25*8,3*8)
          CALL FI632(CPDS,KPTR,KPDSI,IRET)
          LMATCH=.TRUE.
          IP=1
          DOWHILE(LMATCH.AND.IP.LE.22)
            LMATCH=KPDS(IP).EQ.-1.OR.KPDS(IP).EQ.KPDSI(IP)
            IP=IP+1
          ENDDO
          IF(LMATCH) THEN
c           KPDS=KPDSI
	    call ifillv(kpds,kpdsi,100)
            INUM=N
            CALL GBYTEc(CBUF,LSKIP,(N-1)*NLEN*8,4*8)
            CALL GBYTEc(CBUF,LGRIB,(N-1)*NLEN*8+20*8,4*8)
          ENDIF
          N=N+1
        ENDDO
      ENDIF
      RETURN
      END
C-----------------------------------------------------------------------
	subroutine ifill(ia,n,ival)
	integer ia(n),ival
	do i = 1, n
	    ia(i) = ival
	enddo
	return
	end
	subroutine ifillv(ia,ib,n)
	integer ia(n), ib(n)
	do i = 1, n
	    ia(n) = ib(n)
	enddo
	return
	end
